package com.ejie.m62fb.dao;

import com.ejie.x38.dto.Pagination;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import javax.annotation.Resource;
import javax.sql.DataSource;
import org.springframework.dao.support.DataAccessUtils;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.RowMapper;
import org.springframework.stereotype.Repository;
import org.springframework.transaction.annotation.Transactional;

import com.ejie.m62fb.i18n.I18nString;
import com.ejie.m62fb.model.M62fbSituacionViv;

/**
 * M62fbSituacionVivDaoImpl generated by UDA, 24-oct-2012 16:48:53.
 * 
XXXX
 */

@Repository
@Transactional
public class M62fbSituacionVivDaoImpl implements M62fbSituacionVivDao {
	private JdbcTemplate jdbcTemplate;
	private RowMapper<M62fbSituacionViv> rwMap = new RowMapper<M62fbSituacionViv>() {
		public M62fbSituacionViv mapRow(ResultSet resultSet, int rowNum)
				throws SQLException {
			// Valor por defecto???
			HashMap<String, String> mp = new HashMap<String, String>();
			mp.put("es", resultSet.getString("DESTABLACAS"));
			mp.put("eu", resultSet.getString("DESTABLAEUS"));

			return new M62fbSituacionViv(resultSet.getString("CODTABLA"),
					new I18nString(resultSet.getString("DESTABLACAS"), mp));
		}
	};

	/**
	 * Method use to set the datasource.
	 * 
	 * @param dataSource
	 *            DataSource
	 * @return
	 */
	@Resource
	public void setDataSource(DataSource dataSource) {
		this.jdbcTemplate = new JdbcTemplate(dataSource);
	}

	/**
	 * Inserts a single row in the M62fbSituacionViv table.
	 * 
	 * @param m62fbsituacionviv
	 *            Pagination
	 * @return M62fbSituacionViv
	 */
	public M62fbSituacionViv add(M62fbSituacionViv m62fbsituacionviv) {
		String query = "INSERT INTO M62P28V0S00_SITUACION_VIV (COD_TABLA, DES_TABLA_CAS) VALUES (?)";
		this.jdbcTemplate.update(query, m62fbsituacionviv.getCodTabla());
		return m62fbsituacionviv;
	}

	/**
	 * Updates a single row in the M62fbSituacionViv table.
	 * 
	 * @param m62fbsituacionviv
	 *            Pagination
	 * @return M62fbSituacionViv
	 */
	public M62fbSituacionViv update(M62fbSituacionViv m62fbsituacionviv) {
		String query = "UPDATE M62P28V0S00_SITUACION_VIV SET  WHERE COD_TABLA=? ";
		this.jdbcTemplate.update(query, m62fbsituacionviv.getCodTabla());
		return m62fbsituacionviv;
	}

	/**
	 * Finds a single row in the M62fbSituacionViv table.
	 * 
	 * @param m62fbsituacionviv
	 *            Pagination
	 * @return M62fbSituacionViv
	 */
	@Transactional(readOnly = true, timeout = 500)
	public M62fbSituacionViv find(M62fbSituacionViv m62fbsituacionviv) {
		String query = "SELECT t1.COD_TABLA CODTABLA, t1.DES_TABLA_CAS DESTABLACAS, t1.DES_TABLA_EUS DESTABLAEUS FROM M62P28V0S00_SITUACION_VIV t1  WHERE t1.COD_TABLA = ?  ";

		List<M62fbSituacionViv> m62fbsituacionvivList = this.jdbcTemplate
				.query(query, this.rwMap, m62fbsituacionviv.getCodTabla());
		return (M62fbSituacionViv) DataAccessUtils
				.uniqueResult(m62fbsituacionvivList);
	}

	/**
	 * Removes a single row in the M62fbSituacionViv table.
	 * 
	 * @param m62fbsituacionviv
	 *            Pagination
	 * @return
	 */
	public void remove(M62fbSituacionViv m62fbsituacionviv) {
		String query = "DELETE FROM M62P28V0S00_SITUACION_VIV WHERE COD_TABLA=? ";
		this.jdbcTemplate.update(query, m62fbsituacionviv.getCodTabla());
	}

	/**
	 * Finds a List of rows in the M62fbSituacionViv table.
	 * 
	 * @param m62fbsituacionviv
	 *            M62fbSituacionViv
	 * @param pagination
	 *            Pagination
	 * @return List
	 */
	@Transactional(readOnly = true, timeout = 500)
	public List<M62fbSituacionViv> findAll(M62fbSituacionViv m62fbsituacionviv,
			Pagination pagination) {
		StringBuilder query = new StringBuilder(
				"SELECT  t1.COD_TABLA CODTABLA,t1.DES_TABLA_CAS DESTABLACAS,t1.DES_TABLA_EUS DESTABLAEUS ");
		query.append("FROM M62P28V0S00_SITUACION_VIV t1 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereMap(m62fbsituacionviv);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);
		query.append(" ORDER BY t1.DES_TABLA_CAS ASC");

		List<?> params = (List<?>) mapaWhere.get("params");

		if (pagination != null) {
			query = pagination.getPaginationQuery(query);
		}

		return (List<M62fbSituacionViv>) this.jdbcTemplate.query(
				query.toString(), this.rwMap, params.toArray());
	}

	/**
	 * Counts rows in the M62fbSituacionViv table.
	 * 
	 * @param m62fbsituacionviv
	 *            M62fbSituacionViv
	 * @return Long
	 */
	@Transactional(readOnly = true, timeout = 500)
	public Long findAllCount(M62fbSituacionViv m62fbsituacionviv) {
		StringBuilder query = new StringBuilder(
				"SELECT COUNT(1) FROM M62P28V0S00_SITUACION_VIV t1 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereMap(m62fbsituacionviv);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		return this.jdbcTemplate.queryForLong(query.toString(),
				params.toArray());
	}

	/**
	 * Finds rows in the M62fbSituacionViv table using like.
	 * 
	 * @param m62fbsituacionviv
	 *            M62fbSituacionViv
	 * @param pagination
	 *            Pagination
	 * @param startsWith
	 *            Boolean
	 * @return List
	 */
	@Transactional(readOnly = true, timeout = 500)
	public List<M62fbSituacionViv> findAllLike(
			M62fbSituacionViv m62fbsituacionviv, Pagination pagination,
			Boolean startsWith) {
		StringBuilder query = new StringBuilder(
				"SELECT  t1.COD_TABLA CODTABLA,t1.DES_TABLA_CAS DESTABLACAS,t1.DES_TABLA_EUS DESTABLAEUS ");
		query.append("FROM M62P28V0S00_SITUACION_VIV t1 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereLikeMap(m62fbsituacionviv,
				startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		if (pagination != null) {
			query = pagination.getPaginationQuery(query);
		}

		return (List<M62fbSituacionViv>) this.jdbcTemplate.query(
				query.toString(), this.rwMap, params.toArray());
	}

	/**
	 * Counts rows in the M62fbSituacionViv table using like.
	 * 
	 * @param m62fbsituacionviv
	 *            M62fbSituacionViv
	 * @param startsWith
	 *            Boolean
	 * @return Long
	 */
	@Transactional(readOnly = true, timeout = 500)
	public Long findAllLikeCount(M62fbSituacionViv m62fbsituacionviv,
			Boolean startsWith) {
		StringBuilder query = new StringBuilder(
				"SELECT COUNT(1) FROM M62P28V0S00_SITUACION_VIV t1 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereLikeMap(m62fbsituacionviv,
				startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		return this.jdbcTemplate.queryForLong(query.toString(),
				params.toArray());
	}

	/**
	 * Returns a map with the needed value to create the conditions to filter by
	 * the M62fbSituacionViv entity
	 * 
	 * @param m62fbsituacionviv
	 *            M62fbSituacionViv Bean with the criteria values to filter by.
	 * @return Map created with two keys key query stores the sql query syntax
	 *         key params stores the parameter values to be used in the
	 *         condition sentence.
	 */
	// CHECKSTYLE:OFF CyclomaticComplexity - Generación de código de UDA
	private Map<String, ?> getWhereMap(M62fbSituacionViv m62fbsituacionviv) {

		StringBuffer where = new StringBuffer(
				M62fbSituacionVivDaoImpl.STRING_BUILDER_INIT);
		List<Object> params = new ArrayList<Object>();

		if (m62fbsituacionviv != null
				&& m62fbsituacionviv.getCodTabla() != null) {
			where.append(" AND t1.COD_TABLA = ?");
			params.add(m62fbsituacionviv.getCodTabla());
		}
		/*
		 * if (m62fbsituacionviv != null && m62fbsituacionviv.getDesTablaCas()
		 * != null) { where.append(" AND t1.DES_TABLA_CAS = ?");
		 * params.add(m62fbsituacionviv.getDesTablaCas()); }
		 */

		Map<String, Object> mapWhere = new HashMap<String, Object>();
		mapWhere.put("query", where);
		mapWhere.put("params", params);

		return mapWhere;
	}

	// CHECKSTYLE:ON CyclomaticComplexity - Generación de código de UDA

	/**
	 * Returns a map with the needed value to create the conditions to filter by
	 * the M62fbSituacionViv entity
	 * 
	 * @param m62fbsituacionviv
	 *            M62fbSituacionViv Bean with the criteria values to filter by.
	 * @param startsWith
	 *            Boolean
	 * @return Map created with two keys key query stores the sql query syntax
	 *         key params stores the parameter values to be used in the
	 *         condition sentence.
	 */
	// CHECKSTYLE:OFF CyclomaticComplexity - Generación de código de UDA
	private Map<String, ?> getWhereLikeMap(M62fbSituacionViv m62fbsituacionviv,
			Boolean startsWith) {

		StringBuffer where = new StringBuffer(
				M62fbSituacionVivDaoImpl.STRING_BUILDER_INIT);
		List<Object> params = new ArrayList<Object>();

		if (m62fbsituacionviv != null
				&& m62fbsituacionviv.getCodTabla() != null) {
			where.append(" AND UPPER(t1.COD_TABLA) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(m62fbsituacionviv.getCodTabla().toUpperCase() + "%");
			} else {
				params.add("%" + m62fbsituacionviv.getCodTabla().toUpperCase()
						+ "%");
			}
			where.append(" AND t1.COD_TABLA IS NOT NULL");
		}
		/*
		 * if (m62fbsituacionviv != null && m62fbsituacionviv.getDesTablaCas()
		 * != null) {
		 * where.append(" AND UPPER(t1.DES_TABLA_CAS) like ? ESCAPE  '\\'"); if
		 * (startsWith) {
		 * params.add(m62fbsituacionviv.getDesTablaCas().toUpperCase() + "%"); }
		 * else { params.add("%" +
		 * m62fbsituacionviv.getDesTablaCas().toUpperCase() + "%"); }
		 * where.append(" AND t1.DES_TABLA_CAS IS NOT NULL"); }
		 */

		Map<String, Object> mapWhere = new HashMap<String, Object>();
		mapWhere.put("query", where);
		mapWhere.put("params", params);

		return mapWhere;
	}

	// CHECKSTYLE:ON CyclomaticComplexity - Generación de código de UDA

	/**
	 * StringBuilder initilization value
	 */
	public static final int STRING_BUILDER_INIT = 4096;
}
