package com.ejie.m62fb.dao.registroVPP;

import com.ejie.m62fb.dao.SQLGenericas;
import com.ejie.m62fb.utils.constants.BDConstantes;

public class AlojamientoDotacionalDaoSql {

	/**
	 * StringBuilder initilization value
	 */
	public static final int STRING_BUILDER_INIT = 4096;

	public static final String TABLA = BDConstantes.ALOJAMIENTO_DOTACIONAL;
	public static final String VISTA = BDConstantes.VIS_ALOJAMIENTO_DOTACIONAL;
	public static final String TABLA_INQ_AD = BDConstantes.INQUILINOAD;

	public static final String ALIAS = " AD";
	public static final String ALIAS_INQ_AD = " INQ_AD";

	public static final String ALIAS_DIR = "";

	public static final String SQL_INSERT = "INSERT INTO"
			+ TABLA
			+ "(NUM_EXPEDIENTE, COD_ALOJAMIENTO"
			+ ", SUP_UTIL_ALOJ, NUM_DORMITORIOS, NUM_BANYOS, IND_ALOJ_ADAPTADA"
			+ ", NUM_FIJO_IBI, COD_REF_CATASTRAL, TEX_OBSERVACIONES"
			+ ", NUM_TIPO_REGULACION, NUM_TIPO_REG_ACCESO, NUM_CLA_INICIATIVA, NUM_TIPO_PROMOTOR, NUM_TIPO_PROPIETARIO"
			+ ", NUM_ADJUDICACION, NUM_ADJ_QUIEN, NUM_ADJ_COMO"
			+ SQLGenericas.INSERT_DIRECCION_CLASS_SQL
			+ SQLGenericas.INSERT_ABSTRACT_CLASS_SQL + ") VALUES (" + "?,?"
			+ ",?,?,?,?" + ",?,?,?" + ",?,?,?,?,?" + ",?,?,?"
			+ SQLGenericas.INSERT_DIRECCION_CLASS_QUESTION_TAGS
			+ SQLGenericas.INSERT_ABSTRACT_CLASS_QUESTION_TAGS + ")";

	public static final String SQL_UPDATE = "UPDATE "
			+ TABLA
			+ " SET NUM_EXPEDIENTE = ?, COD_ALOJAMIENTO = ?"
			+ ", SUP_UTIL_ALOJ = ?, NUM_DORMITORIOS = ?, NUM_BANYOS = ?, IND_ALOJ_ADAPTADA = ?"
			+ ", NUM_FIJO_IBI = ?, COD_REF_CATASTRAL = ?, TEX_OBSERVACIONES = ?"
			+ ", NUM_TIPO_REGULACION = ?, NUM_TIPO_REG_ACCESO = ?, NUM_CLA_INICIATIVA = ?, NUM_TIPO_PROMOTOR = ?, NUM_TIPO_PROPIETARIO = ?"
			+ ", NUM_ADJUDICACION = ?, NUM_ADJ_QUIEN = ?, NUM_ADJ_COMO = ?"
			+ SQLGenericas.UPDATE_DIRECCION_CLASS_SQL
			+ SQLGenericas.UPDATE_ABSTRACT_CLASS_SQL + " WHERE ID_ALOJ_REG=?";

	private static final String SQL_SELECT = "SELECT" //
			+ AlojamientoDotacionalDaoSql.ALIAS
			+ ".ID_ALOJ_REG IDALOJREG, "
			+ AlojamientoDotacionalDaoSql.ALIAS
			+ ".ID_ALOJAMIENTO IDALOJAMIENTO, "
			+ AlojamientoDotacionalDaoSql.ALIAS
			+ ".NUM_EXPEDIENTE NUMEXPEDIENTE, "
			+ AlojamientoDotacionalDaoSql.ALIAS
			+ ".COD_ALOJAMIENTO CODALOJAMIENTO, "
			+ AlojamientoDotacionalDaoSql.ALIAS
			+ ".ID_EMPLAZAMIENTO IDEMPLAZAMIENTO, "
			+ AlojamientoDotacionalDaoSql.ALIAS
			+ ".SUP_UTIL_ALOJ SUPUTILALOJ, "
			+ AlojamientoDotacionalDaoSql.ALIAS
			+ ".IND_ALOJ_ADAPTADA INDALOJADAPTADA, "
			+ AlojamientoDotacionalDaoSql.ALIAS
			+ ".NUM_DORMITORIOS NUMDORMITORIOS, "
			+ AlojamientoDotacionalDaoSql.ALIAS
			+ ".NUM_BANYOS NUMBANYOS, "
			+ AlojamientoDotacionalDaoSql.ALIAS
			+ ".NUM_FIJO_IBI NUMFIJOIBI, "
			+ AlojamientoDotacionalDaoSql.ALIAS
			+ ".COD_REF_CATASTRAL CODREFCATASTRAL, "
			+ AlojamientoDotacionalDaoSql.ALIAS
			+ ".NUM_TIPO_REGULACION NUMTIPOREGULACION, "
			+ AlojamientoDotacionalDaoSql.ALIAS
			+ ".NUM_TIPO_REG_ACCESO NUMTIPOREGACCESO, "
			+ AlojamientoDotacionalDaoSql.ALIAS
			+ ".NUM_CLA_INICIATIVA NUMCLAINICIATIVA, "
			+ AlojamientoDotacionalDaoSql.ALIAS
			+ ".NUM_TIPO_PROMOTOR NUMTIPOPROMOTOR, "
			+ AlojamientoDotacionalDaoSql.ALIAS
			+ ".NUM_TIPO_PROPIETARIO NUMTIPOPROPIETARIO, "
			+ AlojamientoDotacionalDaoSql.ALIAS
			+ ".NUM_ADJ_QUIEN NUMADJQUIEN, "
			+ AlojamientoDotacionalDaoSql.ALIAS
			+ ".NUM_ADJ_COMO NUMADJCOMO, "
			+ AlojamientoDotacionalDaoSql.ALIAS
			+ ".NUM_ADJUDICACION NUMADJUDICACION, "
			+ AlojamientoDotacionalDaoSql.ALIAS
			+ ".TEX_OBSERVACIONES TEXOBSERVACIONES, "
			+ AlojamientoDotacionalDaoSql.ALIAS
			+ ".FEC_INI_GESTION FECINIGESTION, "
			+ AlojamientoDotacionalDaoSql.ALIAS
			+ ".FEC_FIN_GESTION FECFINGESTION, "
			+ AlojamientoDotacionalDaoSql.ALIAS
			+ ".NUM_ORGANO_GESTOR NUMORGANOGESTOR, "
			+ AlojamientoDotacionalDaoSql.ALIAS
			+ ".FEC_ENV_ORG_GESTOR FECENVORGGESTOR "
			// Direccion
			+ SQLGenericas.getSqlCamposDireccionCompleta(ALIAS, ALIAS_DIR)
			// AbstractM62FBModel
			+ SQLGenericas.getSqlCamposAbstractClass(ALIAS);

	private static final String SQL_FROM = " FROM " + VISTA + ALIAS;

	private static final String SQL_WHERE = " WHERE " + ALIAS
			+ ".ID_ALOJ_REG = ?";

	public static final String SQL_WHERE_ALL = " WHERE 1 = 1 ";

	private static final String SQL_WHERE_FOR_UPDATE = SQL_WHERE
			+ " AND FEH_ULT_MODIF = ?";

	public static final String SQL_FIND = SQL_SELECT + SQL_FROM + SQL_WHERE;

	public static final String SQL_SELECT_COUNT = "SELECT COUNT(1)";

	public static final String SQL_CHECK_FOR_UPDATE = SQL_SELECT_COUNT
			+ SQL_FROM + SQL_WHERE_FOR_UPDATE;

	public static final String SQL_FIND_ALL = SQL_SELECT + SQL_FROM;

	public static final String SQL_FIND_ALL_COUNT = SQL_SELECT_COUNT + SQL_FROM;

	// FIND ALL CON TITULAR
	private static final String SQL_FROM_CON_TITULAR = " FROM " + VISTA + ALIAS
			+ ", " + TABLA_INQ_AD + ALIAS_INQ_AD;
	public static final String SQL_WHERE_ALL_CON_TITULAR = " WHERE " + ALIAS
			+ ".ID_ALOJ_REG = " + ALIAS_INQ_AD + ".ID_ALOJ_REG ";

	public static final String SQL_FIND_ALL_COUNT_CON_TITULAR = SQL_SELECT_COUNT
			+ SQL_FROM_CON_TITULAR;
	public static final String SQL_FIND_ALL_CON_TITULAR = SQL_SELECT
			+ SQL_FROM_CON_TITULAR;
}