package com.ejie.m62fb.dao.registroVPP;

import java.math.BigDecimal;
import java.util.List;

import com.ejie.m62fb.model.ContratoVivienda;
import com.ejie.m62fb.model.ContratoViviendaActMasiva;
import com.ejie.m62fb.model.plsql.PlSqlOutputError;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * ContratoViviendaDao generated by UDA, 16-sep-2015 14:03:29.
 * 
XXXX
 */

public interface ContratoViviendaDao {

	/**
	 * Inserts a single row in the ContratoVivienda table.
	 * 
	 * @param contratovivienda
	 *            ContratoVivienda
	 * @return ContratoVivienda
	 */
	ContratoVivienda add(ContratoVivienda contratovivienda);

	/**
	 * Updates a single row in the ContratoVivienda table.
	 * 
	 * @param contratovivienda
	 *            ContratoVivienda
	 * @return ContratoVivienda
	 */
	ContratoVivienda update(ContratoVivienda contratovivienda);

	/**
	 * Finds a single row in the ContratoVivienda table.
	 * 
	 * @param contratovivienda
	 *            ContratoVivienda
	 * @return ContratoVivienda
	 */
	ContratoVivienda find(ContratoVivienda contratovivienda);

	/**
	 * Finds a single row in the ContratoVivienda table.
	 * 
	 * @param contratovivienda
	 *            ContratoVivienda
	 * @return ContratoVivienda
	 */
	ContratoVivienda findForUpdate(ContratoVivienda contratovivienda);

	/**
	 * Removes a single row in the ContratoVivienda table.
	 * 
	 * @param contratovivienda
	 *            ContratoVivienda
	 */
	void remove(ContratoVivienda contratovivienda);

	/**
	 * Finds a List of rows in the ContratoVivienda table.
	 * 
	 * @param contratovivienda
	 *            ContratoVivienda
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List
	 */
	List<ContratoVivienda> findAll(ContratoVivienda contratovivienda,
			JQGridRequestDto jqGridRequestDto);
	
	/**
	 * Finds a List of rows in the ContratoVivienda table.
	 * 
	 * @param contratovivienda
	 *            ContratoVivienda
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List
	 */
	List<ContratoVivienda> findAllSolPlatea(ContratoVivienda contratovivienda,
	        JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds a List of rows in the ContratoVivienda table.
	 * 
	 * @param contratovivienda
	 *            ContratoViviendaActMasiva
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List
	 */
	List<ContratoViviendaActMasiva> findAllActMasiva(
			ContratoViviendaActMasiva contratoviviendaActMasiva,
			JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the ContratoVivienda table using like.
	 * 
	 * @param contratovivienda
	 *            ContratoVivienda
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List
	 */
	List<ContratoVivienda> findAllLike(ContratoVivienda contratovivienda,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Counts rows in the ContratoVivienda table using like.
	 * 
	 * @param contratovivienda
	 *            ContratoVivienda
	 * @param startsWith
	 *            Boolean
	 * @return Long
	 */
	Long findAllLikeCount(ContratoVivienda contratovivienda, Boolean startsWith);

	/**
	 * Counts rows in the ContratoVivienda table.
	 * 
	 * @param contratovivienda
	 *            ContratoVivienda
	 * @return Long
	 */
	Long findAllCount(ContratoVivienda contratovivienda);

	/**
	 * Reorder selection.
	 * 
	 * @param filterContratoVivienda
	 *            ContratoVivienda
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<ContratoVivienda>>
	 */
	List<TableRowDto<ContratoVivienda>> reorderSelection(
			ContratoVivienda filterContratoVivienda,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Returns a Boolean. If it exists in CONTRATO_VIVIENDA table true,
	 * otherwise false.
	 * 
	 * @param contratoVivienda
	 *            ContratoVivienda
	 * @return boolean
	 */
	boolean findAllCountContratosVivienda(ContratoVivienda contratoVivienda);

	/**
	 * Returns a BigDecimal. Máximo NUM_PROPIETARIO que hay para una vivienda en
	 * la tabla CONTRATO_VIVIENDA e incrementandolo en 1.
	 * 
	 * @param numVivienda
	 *            BigDecimal
	 * @return BigDecimal
	 */
	BigDecimal findNumPropietarioMaxMasUno(BigDecimal numVivienda);

	/**
	 * Funcion que valida si al visar un contrato se esta superando el importe
	 * maximo autorizado en la promocion.
	 * 
	 * @param numExpediente
	 *            String
	 * @param idVivienda
	 *            BigDecimal
	 * @return PlSqlOutputError
	 */
	PlSqlOutputError validarImporteAutorizado(String numExpediente,
			BigDecimal idVivienda);

	/**
	 * Funcion que busca si existe algun contrato de primera transmision para la
	 * vivienda seleccionada.
	 * 
	 * @param BigDecimal
	 *            numVivienda
	 * @return Long
	 */
	Long findContratoPrimerTrans(BigDecimal numVivienda);
}
