package com.ejie.m62fb.dao.registroVPP;

import java.util.List;

import com.ejie.m62fb.model.SolicitudReserva;
import com.ejie.x38.dto.JQGridRequestDto;

/**
 * SolicitudReservaDao.
 * 
XXXX
 */
public interface SolicitudReservaDao {

	/**
	 * Inserts a single row in the SolicitudReserva table.
	 * 
	 * @param solicitudReserva
	 *            SolicitudReserva
	 * @return SolicitudReserva
	 */
	SolicitudReserva add(SolicitudReserva solicitudReserva);

	/**
	 * Actualiza el estado de la solicitud a "APERTURADO(2)" e informa el
	 * numExpedientePlatea introducido en la apertura
	 * 
	 * @param solicitudReserva
	 *            SolicitudReserva(idExpedientePlatea(folderId),
	 *            numExpedientePlatea(folderNumber))
	 */
	void updateEstadoApertura(SolicitudReserva solicitudReserva);

	/**
	 * Actualiza el estado de la solicitud a "NOTIFICADO(3)"
	 * 
	 * @param solicitudReserva
	 *            SolicitudReserva(idExpedientePlatea(folderId))
	 */
	void updateEstadoNotificacion(SolicitudReserva solicitudReserva);

	/**
	 * Finds a single row in the SolicitudReserva table.
	 * 
	 * @param solicitudReserva
	 *            SolicitudReserva
	 * @return SolicitudReserva
	 */
	SolicitudReserva find(SolicitudReserva solicitudesreserva);

	/**
	 * Finds a List of rows in the SolicitudReserva table.
	 * 
	 * @param solicitudReserva
	 *            SolicitudReserva
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List
	 */
	List<SolicitudReserva> findAll(SolicitudReserva solicitudReserva,
			JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the SolicitudReserva table using like.
	 * 
	 * @param solicitudReserva
	 *            SolicitudReserva
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List
	 */
	List<SolicitudReserva> findAllLike(SolicitudReserva solicitudReserva,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Counts rows in the SolicitudReserva table using like.
	 * 
	 * @param solicitudReserva
	 *            SolicitudReserva
	 * @param startsWith
	 *            Boolean
	 * @return Long
	 */
	Long findAllLikeCount(SolicitudReserva solicitudReserva, Boolean startsWith);

	/**
	 * Counts rows in the SolicitudReserva table.
	 * 
	 * @param solicitudReserva
	 *            SolicitudReserva
	 * @return Long
	 */
	Long findAllCount(SolicitudReserva solicitudReserva);
}