package com.ejie.m62fb.dao.registroVPP;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.annotation.Resource;
import javax.sql.DataSource;

import org.springframework.dao.support.DataAccessUtils;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.RowMapper;
import org.springframework.stereotype.Repository;
import org.springframework.transaction.annotation.Transactional;

import com.ejie.m62fb.model.ViviendaDisponible;
import com.ejie.m62fb.model.tipos.RegimenAcceso;
import com.ejie.m62fb.model.tipos.RegimenTenencia;
import com.ejie.m62fb.utils.sql.BDUtils;
import com.ejie.m62fb.utils.sql.UtilsResulSet;
import com.ejie.x38.dao.RowNumResultSetExtractor;
import com.ejie.x38.dto.JQGridManager;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * ViviendaDisponibleDaoImpl generated by UDA, 02-dic-2015 8:59:58.
 * 
XXXX
 */

@Repository
@Transactional
public class ViviendaDisponibleDaoImpl implements ViviendaDisponibleDao {
	private JdbcTemplate jdbcTemplate;

	/*
	 * ROW_MAPPERS
	 */
	private final RowMapper<ViviendaDisponible> rwMap = new RowMapper<ViviendaDisponible>() {
		@Override
		public ViviendaDisponible mapRow(ResultSet resultSet, int rowNum)
				throws SQLException {
			ViviendaDisponible viviendaDisponible = new ViviendaDisponible();

			// Num. Vivienda
			viviendaDisponible.setNumVivienda(UtilsResulSet.getBigDecimal(
					resultSet, "NUMVIVIENDA"));
			// Superficie Util Vivienda
			viviendaDisponible.setSupUtilViv(UtilsResulSet.getBigDecimal(
					resultSet, "SUPUTILVIV"));
			// Nº Dormitorios
			viviendaDisponible.setNumDormitorios(UtilsResulSet.getLong(
					resultSet, "NUMDORMITORIOS"));
			// Indicador Vivienda Adaptada
			viviendaDisponible.setIndVivAdaptada(resultSet
					.getString("INDVIVADAPTADA"));
			// Direccion
			viviendaDisponible.setDireccion(UtilsResulSet.getDireccionCompleta(
					resultSet, null));
			// Regimen Acceso
			RegimenAcceso regimenAcceso = new RegimenAcceso();
			regimenAcceso.setCodTabla(UtilsResulSet.getString(resultSet,
					"CODREGACCESO"));
			regimenAcceso.setDescripcionEs(UtilsResulSet.getString(resultSet,
					"DESCREGACCESOES"));
			regimenAcceso.setDescripcionEu(UtilsResulSet.getString(resultSet,
					"DESCREGACCESOEU"));
			viviendaDisponible.setRegimenAcceso(regimenAcceso);
			// Regimen Tenencia
			RegimenTenencia regimenTenencia = new RegimenTenencia();
			regimenTenencia.setCodTabla(resultSet.getString("CODREGTENENCIA"));
			regimenTenencia.setDescripcionEs(resultSet
					.getString("DESCREGTENENCIAES"));
			regimenTenencia.setDescripcionEu(resultSet
					.getString("DESCREGTENENCIAEU"));
			viviendaDisponible.setRegimenTenencia(regimenTenencia);
			// Indicador Disponibilidad
			viviendaDisponible.setIndDisponible(resultSet
					.getString("INDDISPONIBLE"));
			// Importe PVP Total
			viviendaDisponible.setImcPvpTotal(UtilsResulSet.getBigDecimal(
					resultSet, "IMCPVPTOTAL"));
			// Numero Garaje
			viviendaDisponible.setCodElemG(UtilsResulSet.getString(resultSet,
					"CODELEMG"));
			// Superficie Util Garaje
			viviendaDisponible.setSupUtilG(UtilsResulSet.getBigDecimal(
					resultSet, "SUPUTILG"));
			// Numero Trastero
			viviendaDisponible.setCodElemT(UtilsResulSet.getString(resultSet,
					"CODELEMT"));
			// Superficie Util Trastero
			viviendaDisponible.setSupUtilT(UtilsResulSet.getBigDecimal(
					resultSet, "SUPUTILT"));
			// Nº Expediente
			viviendaDisponible.setNumExpediente(resultSet
					.getString("NUMEXPEDIENTE"));

			return viviendaDisponible;
		}
	};

	private final RowMapper<ViviendaDisponible> rwMapPK = new RowMapper<ViviendaDisponible>() {
		@Override
		public ViviendaDisponible mapRow(ResultSet resultSet, int rowNum)
				throws SQLException {
			return new ViviendaDisponible(
					resultSet.getBigDecimal("NUMVIVIENDA"));
		}
	};

	/**
	 * Method use to set the datasource.
	 * 
	 * @param dataSource
	 *            DataSource
	 * @return
	 */
	@Resource
	public void setDataSource(DataSource dataSource) {
		this.jdbcTemplate = new JdbcTemplate(dataSource);
	}

	/*
	 * OPERACIONES CRUD
	 */

	/**
	 * Inserts a single row in the ViviendaDisponible table.
	 * 
	 * @param viviendadisponible
	 *            ViviendaDisponible
	 * @return ViviendaDisponible
	 */
	@Override
	public ViviendaDisponible add(ViviendaDisponible viviendadisponible) {
		// String query =
		// "INSERT INTO VIVIENDA_DISPONIBLES (NUM_VIVIENDA, SUP_UTIL_VIV, NUM_DORMITORIOS, IND_VIV_ADAPTADA, ID_PAIS, DESC_PAIS_ES, DESC_PAIS_EU, ID_PROVINCIA, DESC_PROVINCIA, ID_MUNICIPIO, DESC_MUNICIPIO, ID_LOCALIDAD, DESC_LOCALIDAD, ID_CALLE, DESC_CALLE_ES, DESC_CALLE_EU, TIPO_VIA, BLOQUE, NUMERO, BIS, CODIGO_POSTAL, ESCALERA, PISO, MANO, PUERTA, COD_REG_ACCESO, DESC_REG_ACCESO_ES, DESC_REG_ACCESO_EU, COD_REG_TENENCIA, DESC_REG_TENENCIA_ES, DESC_REG_TENENCIA_EU, IND_DISPONIBLE, IMC_PVP_TOTAL, COD_ELEM_G, SUP_UTIL_G, COD_ELEM_T, SUP_UTIL_T) VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)";
		return viviendadisponible;
	}

	/**
	 * Updates a single row in the ViviendaDisponible table.
	 * 
	 * @param viviendadisponible
	 *            ViviendaDisponible
	 * @return ViviendaDisponible
	 */
	@Override
	public ViviendaDisponible update(ViviendaDisponible viviendadisponible) {
		// String query =
		// "UPDATE VIVIENDA_DISPONIBLES SET  WHERE NUM_VIVIENDA=? AND SUP_UTIL_VIV=? AND NUM_DORMITORIOS=? AND IND_VIV_ADAPTADA=? AND ID_PAIS=? AND DESC_PAIS_ES=? AND DESC_PAIS_EU=? AND ID_PROVINCIA=? AND DESC_PROVINCIA=? AND ID_MUNICIPIO=? AND DESC_MUNICIPIO=? AND ID_LOCALIDAD=? AND DESC_LOCALIDAD=? AND ID_CALLE=? AND DESC_CALLE_ES=? AND DESC_CALLE_EU=? AND TIPO_VIA=? AND BLOQUE=? AND NUMERO=? AND BIS=? AND CODIGO_POSTAL=? AND ESCALERA=? AND PISO=? AND MANO=? AND PUERTA=? AND COD_REG_ACCESO=? AND DESC_REG_ACCESO_ES=? AND DESC_REG_ACCESO_EU=? AND COD_REG_TENENCIA=? AND DESC_REG_TENENCIA_ES=? AND DESC_REG_TENENCIA_EU=? AND IND_DISPONIBLE=? AND IMC_PVP_TOTAL=? AND COD_ELEM_G=? AND SUP_UTIL_G=? AND COD_ELEM_T=? AND SUP_UTIL_T=?";
		return viviendadisponible;
	}

	/**
	 * Finds a single row in the ViviendaDisponible table.
	 * 
	 * @param viviendadisponible
	 *            ViviendaDisponible
	 * @return ViviendaDisponible
	 */
	@Override
	@Transactional(readOnly = true)
	public ViviendaDisponible find(ViviendaDisponible viviendadisponible) {
		String query = ViviendaDisponibleDaoSql.SQL_FIND;

		List<ViviendaDisponible> viviendaDisponibleList = this.jdbcTemplate
				.query(query, this.rwMap, viviendadisponible.getNumVivienda());
		return DataAccessUtils.uniqueResult(viviendaDisponibleList);

	}

	/**
	 * Removes a single row in the ViviendaDisponible table.
	 * 
	 * @param viviendadisponible
	 *            ViviendaDisponible
	 * @return
	 */
	@Override
	public void remove(ViviendaDisponible viviendadisponible) {
		// String query =
		// "DELETE FROM VIVIENDA_DISPONIBLES WHERE NUM_VIVIENDA=? AND SUP_UTIL_VIV=? AND NUM_DORMITORIOS=? AND IND_VIV_ADAPTADA=? AND ID_PAIS=? AND DESC_PAIS_ES=? AND DESC_PAIS_EU=? AND ID_PROVINCIA=? AND DESC_PROVINCIA=? AND ID_MUNICIPIO=? AND DESC_MUNICIPIO=? AND ID_LOCALIDAD=? AND DESC_LOCALIDAD=? AND ID_CALLE=? AND DESC_CALLE_ES=? AND DESC_CALLE_EU=? AND TIPO_VIA=? AND BLOQUE=? AND NUMERO=? AND BIS=? AND CODIGO_POSTAL=? AND ESCALERA=? AND PISO=? AND MANO=? AND PUERTA=? AND COD_REG_ACCESO=? AND DESC_REG_ACCESO_ES=? AND DESC_REG_ACCESO_EU=? AND COD_REG_TENENCIA=? AND DESC_REG_TENENCIA_ES=? AND DESC_REG_TENENCIA_EU=? AND IND_DISPONIBLE=? AND IMC_PVP_TOTAL=? AND COD_ELEM_G=? AND SUP_UTIL_G=? AND COD_ELEM_T=? AND SUP_UTIL_T=?";
	}

	/**
	 * Finds a list of rows in the ViviendaDisponible table.
	 * 
	 * @param viviendadisponible
	 *            ViviendaDisponible
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<ViviendaDisponible>
	 */
	@Override
	@Transactional(readOnly = true)
	public List<ViviendaDisponible> findAll(
			ViviendaDisponible viviendadisponible,
			JQGridRequestDto jqGridRequestDto) {
		StringBuilder query = new StringBuilder(
				ViviendaDisponibleDaoSql.SQL_FIND_ALL);
		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereMap(viviendadisponible);
		StringBuilder where = new StringBuilder(
				ViviendaDisponibleDaoSql.SQL_WHERE_ALL);
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		if (jqGridRequestDto != null) {
			query = JQGridManager.getPaginationQuery(jqGridRequestDto, query);
		}

		return this.jdbcTemplate.query(query.toString(), this.rwMap,
				params.toArray());
	}

	/**
	 * Finds rows in the ViviendaDisponible table using like.
	 * 
	 * @param viviendadisponible
	 *            ViviendaDisponible
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<ViviendaDisponible>
	 */
	@Override
	@Transactional(readOnly = true)
	public List<ViviendaDisponible> findAllLike(
			ViviendaDisponible viviendadisponible,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		StringBuilder query = new StringBuilder(
				ViviendaDisponibleDaoSql.SQL_FIND_ALL);

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereLikeMap(viviendadisponible,
				startsWith);
		StringBuilder where = new StringBuilder(
				ViviendaDisponibleDaoSql.SQL_WHERE_ALL);
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		if (jqGridRequestDto != null) {
			query = JQGridManager.getPaginationQuery(jqGridRequestDto, query);
		}

		return this.jdbcTemplate.query(query.toString(), this.rwMap,
				params.toArray());
	}

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Counts rows in the ViviendaDisponible table.
	 * 
	 * @param viviendadisponible
	 *            ViviendaDisponible
	 * @return Long
	 */
	@Override
	@Transactional(readOnly = true)
	public Long findAllCount(ViviendaDisponible viviendadisponible) {
		StringBuilder query = new StringBuilder(
				ViviendaReservadaDaoSql.SQL_FIND_ALL_COUNT);

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereMap(viviendadisponible);
		StringBuilder where = new StringBuilder(
				ViviendaDisponibleDaoSql.SQL_WHERE_ALL);
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		return this.jdbcTemplate.queryForLong(query.toString(),
				params.toArray());
	}

	/**
	 * Counts rows in the ViviendaDisponible table using like.
	 * 
	 * @param viviendadisponible
	 *            ViviendaDisponible
	 * @param startsWith
	 *            Boolean
	 * @return Long
	 */
	@Override
	@Transactional(readOnly = true)
	public Long findAllLikeCount(ViviendaDisponible viviendadisponible,
			Boolean startsWith) {
		StringBuilder query = new StringBuilder(
				ViviendaDisponibleDaoSql.SQL_FIND_ALL_COUNT);

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereLikeMap(viviendadisponible,
				startsWith);
		StringBuilder where = new StringBuilder(
				ViviendaDisponibleDaoSql.SQL_WHERE_ALL);
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		return this.jdbcTemplate.queryForLong(query.toString(),
				params.toArray());
	}

	/**
	 * Reorder the data list of ViviendaDisponible selected for rup_table
	 * 
	 * @param viviendadisponible
	 *            ViviendaDisponible
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<ViviendaDisponible>>
	 */
	@Override
	public List<TableRowDto<ViviendaDisponible>> reorderSelection(
			ViviendaDisponible viviendadisponible,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		// SELECT
		StringBuilder query = new StringBuilder(
				ViviendaDisponibleDaoSql.SQL_FIND_ALL);

		// FILTRADO
		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereLikeMap(viviendadisponible,
				startsWith);
		StringBuilder where = new StringBuilder(
				ViviendaDisponibleDaoSql.SQL_WHERE_ALL);
		where.append(mapaWhere.get("query"));
		query.append(where);

		// Parámetros de filtrado
		@SuppressWarnings("unchecked")
		List<Object> filterParamList = (List<Object>) mapaWhere.get("params");

		// SQL para la reordenación
		StringBuilder sbReorderSelectionSQL = JQGridManager.getReorderQuery(
				query, jqGridRequestDto, ViviendaDisponible.class,
				filterParamList, ViviendaDisponibleDaoSql.PK);

		return this.jdbcTemplate.query(sbReorderSelectionSQL.toString(),
				new RowNumResultSetExtractor<ViviendaDisponible>(this.rwMapPK,
						jqGridRequestDto), filterParamList.toArray());
	}

	/*
	 * MÉTODOS PRIVADOS
	 */

	/**
	 * Returns a map with the needed value to create the conditions to filter by
	 * the ViviendaDisponible entity
	 * 
	 * @param viviendadisponible
	 *            ViviendaDisponible Bean with the criteria values to filter by.
	 * @return Map created with two keys key query stores the sql query syntax
	 *         key params stores the parameter values to be used in the
	 *         condition sentence.
	 */
	// CHECKSTYLE:OFF CyclomaticComplexity - Generación de código de UDA
	private Map<String, ?> getWhereMap(ViviendaDisponible viviendadisponible) {

		StringBuilder where = new StringBuilder(
				ViviendaDisponibleDaoImpl.STRING_BUILDER_INIT);
		List<Object> params = new ArrayList<Object>();

		if (viviendadisponible != null) {
			if (viviendadisponible.getNumVivienda() != null) {
				BDUtils.crearFiltroIgual(where, params,
						"VIVIENDADIS.NUM_VIVIENDA",
						viviendadisponible.getNumVivienda());
			}
			if (viviendadisponible.getSupUtilViv() != null) {
				BDUtils.crearFiltroIgual(where, params,
						"VIVIENDADIS.SUP_UTIL_VIV",
						viviendadisponible.getSupUtilViv());
			}
			if (viviendadisponible.getNumDormitorios() != null) {
				BDUtils.crearFiltroIgual(where, params,
						"VIVIENDADIS.NUM_DORMITORIOS",
						viviendadisponible.getNumDormitorios());
			}
		}

		Map<String, Object> mapWhere = new HashMap<String, Object>();
		mapWhere.put("query", where);
		mapWhere.put("params", params);

		return mapWhere;
	}

	// CHECKSTYLE:ON CyclomaticComplexity - Generación de código de UDA

	/**
	 * Returns a map with the needed value to create the conditions to filter by
	 * the ViviendaDisponible entity
	 * 
	 * @param viviendadisponible
	 *            ViviendaDisponible Bean with the criteria values to filter by.
	 * @param startsWith
	 *            Boolean
	 * @return Map created with two keys key query stores the sql query syntax
	 *         key params stores the parameter values to be used in the
	 *         condition sentence.
	 */
	// CHECKSTYLE:OFF CyclomaticComplexity - Generación de código de UDA
	private Map<String, Object> getWhereLikeMap(
			ViviendaDisponible viviendadisponible, Boolean startsWith) {

		StringBuilder where = new StringBuilder(
				ViviendaDisponibleDaoImpl.STRING_BUILDER_INIT);
		List<Object> params = new ArrayList<Object>();

		if (viviendadisponible != null) {
			// Num. Vivienda
			if (viviendadisponible.getNumVivienda() != null) {
				BDUtils.crearFiltroIgual(where, params,
						"VIVIENDADIS.NUM_VIVIENDA",
						viviendadisponible.getNumVivienda());
			}
			// Superficie Util Vivienda
			if (viviendadisponible.getSupUtilViv() != null) {
				BDUtils.crearFiltroIgual(where, params,
						"VIVIENDADIS.SUP_UTIL_VIV",
						viviendadisponible.getSupUtilViv());
			}
			// Nº Dormitorios
			if (viviendadisponible.getNumDormitorios() != null) {
				BDUtils.crearFiltroIgual(where, params,
						"VIVIENDADIS.NUM_DORMITORIOS",
						viviendadisponible.getNumDormitorios());
			}
			// Indicador Vivienda Adaptada
			if (viviendadisponible.getIndVivAdaptada() != null) {
				BDUtils.crearFiltroIgual(where, params,
						"VIVIENDADIS.IND_VIV_ADAPTADA",
						viviendadisponible.getIndVivAdaptada());
			}
			// Direcion
			if (viviendadisponible.getDireccion() != null) {
				BDUtils.crearFiltroDireccion(where, params, "VIVIENDADIS",
						viviendadisponible.getDireccion());
			}
			// Regimen Acceso
			if (viviendadisponible.getRegimenAcceso() != null) {
				if (viviendadisponible.getRegimenAcceso().getCodTabla() != null) {
					BDUtils.crearFiltroIgual(where, params,
							"VIVIENDADIS.COD_REG_ACCESO", viviendadisponible
									.getRegimenAcceso().getCodTabla());
				}
			}
			// Regimen Tenencia
			if (viviendadisponible.getRegimenTenencia() != null) {
				if (viviendadisponible.getRegimenTenencia().getCodTabla() != null) {
					BDUtils.crearFiltroIgual(where, params,
							"VIVIENDADIS.COD_REG_TENENCIA", viviendadisponible
									.getRegimenTenencia().getCodTabla());
				}
			}
			// Nº Dormitorios Desde
			if (viviendadisponible.getNumDormitoriosDesde() != null) {
				BDUtils.crearFiltroDesde(where, params,
						"VIVIENDADIS.NUM_DORMITORIOS",
						viviendadisponible.getNumDormitoriosDesde());
			}

			// Nº Dormitorios Hasta
			if (viviendadisponible.getNumDormitoriosHasta() != null) {
				BDUtils.crearFiltroHasta(where, params,
						"VIVIENDADIS.NUM_DORMITORIOS",
						viviendadisponible.getNumDormitoriosHasta());
			}
			// Superficie Util Vivienda Desde
			if (viviendadisponible.getSupUtilVivDesde() != null) {
				BDUtils.crearFiltroDesde(where, params,
						"VIVIENDADIS.SUP_UTIL_VIV",
						viviendadisponible.getSupUtilVivDesde(), false);
			}

			// Superficie Util Vivienda Hasta
			if (viviendadisponible.getSupUtilVivHasta() != null) {
				BDUtils.crearFiltroHasta(where, params,
						"VIVIENDADIS.SUP_UTIL_VIV",
						viviendadisponible.getSupUtilVivHasta(), false);
			}
		}

		Map<String, Object> mapWhere = new HashMap<String, Object>();
		mapWhere.put("query", where);
		mapWhere.put("params", params);

		return mapWhere;
	}

	// CHECKSTYLE:ON CyclomaticComplexity - Generación de código de UDA

	/**
	 * StringBuilder initilization value
	 */
	public static final int STRING_BUILDER_INIT = 4096;
}
