package com.ejie.m62fb.model.tipos;

public class TipoClave extends AbstractTipoGenericoP28 {

	private static final long serialVersionUID = 1L;
	/**
	 * Valor que hace referencia al nif/dni
	 */
	public static final String DNI = "D";
	/**
	 * Valor que hace referencia al cif
	 */
	public static final String CIF = "C";

	/**
	 * Valor que hace referencia al pasaporte
	 */
	public static final String PASAPORTE = "P";
	/**
	 * Valor que hace referencia al NIE
	 */
	public static final String NIE = "R";
	/**
	 * Valor que hace referencia al campo de BBDD
	 * 
	 * NUM_REGISTRO
	 */
	public static final long NUM_REGISTRO = P28Tipos.TIPO_CLAVE;

	/**
	 * Method 'TipoClave'.
	 */
	public TipoClave() {
		super(TipoClave.NUM_REGISTRO);
	}

	/**
	 * Method 'TipoClave'.
	 * 
	 * @param codTabla
	 *            String
	 */
	public TipoClave(String codTabla) {
		super(TipoClave.NUM_REGISTRO, codTabla);
	}

	/**
	 * Method 'TipoClave'.
	 * 
	 * @param codTabla
	 *            String
	 * @param descripcionEs
	 *            String
	 * @param descripcionEu
	 *            String
	 */
	public TipoClave(String codTabla, String descripcionEs,
			String descripcionEu) {
		super(TipoClave.NUM_REGISTRO, codTabla, descripcionEs,
				descripcionEu);
	}
}