package com.ejie.m62fb.model.tipos;

public class TipoElemento extends AbstractTipoGenericoP28 {

	private static final long serialVersionUID = 1L;

	/**
	 * Valor que hace referencia al campo de BBDD
	 * 
	 * NUM_REGISTRO
	 */
	public static final long NUM_REGISTRO = P28Tipos.TIPO_ELEMENTO;
	/**
	 * Valor que hace referencia al GARAJE
	 */
	public static final String GARAJE = "G";
	/**
	 * Valor que hace referencia al TRASTERO
	 */
	public static final String TRASTERO = "T";
	/**
	 * Valor que hace referencia a la VIVIENDA
	 */
	public static final String VIVIENDA = "V";

	/**
	 * Method 'TipoElemento'.
	 */
	public TipoElemento() {
		super(TipoElemento.NUM_REGISTRO);
	}

	/**
	 * Method 'TipoElemento'.
	 * 
	 * @param codTabla
	 *            String
	 */
	public TipoElemento(String codTabla) {
		super(TipoElemento.NUM_REGISTRO, codTabla);
	}

	/**
	 * Method 'TipoElemento'.
	 * 
	 * @param codTabla
	 *            String
	 * @param descripcionEs
	 *            String
	 * @param descripcionEu
	 *            String
	 */
	public TipoElemento(String codTabla, String descripcionEs,
			String descripcionEu) {
		super(TipoElemento.NUM_REGISTRO, codTabla, descripcionEs, descripcionEu);
	}
}