package com.ejie.m62fb.service;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.ejie.m62fb.dao.ComboR09Dao;
import com.ejie.m62fb.model.tipos.AbstractTipoGenericoR09;

/**
 * ComboR09ServiceImpl
 * 
XXXX
 * 
 */
@Service(value = "comboR09Service")
public class ComboR09ServiceImpl<T extends AbstractTipoGenericoR09> implements
		ComboR09Service<T> {

	@Autowired
	private ComboR09Dao<T> comboR09Dao;

	/**
	 * Devuelve la lista de registros preparados para mostrar en un combo
	 * 
	 * @param filtro
	 *            T
	 * @return List List<? extends AbstractTipoGenericoR09>
	 */
	@Override
	public List<? extends AbstractTipoGenericoR09> findAll(T combo) {
		return comboR09Dao.findAll(combo);
	}

	/**
	 * Devuelve los datos de un registro
	 * 
	 * @param filtro
	 *            T
	 * @return T
	 */
	@Override
	public T find(T combo) {
		return comboR09Dao.find(combo);
	}
}