package com.ejie.m62fb.service.registroVPP;

import java.math.BigDecimal;
import java.util.List;

import com.ejie.m62fb.model.ContratoVivienda;
import com.ejie.m62fb.model.plsql.PlSqlOutputError;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;

/**
 * ContratoViviendaService generated by UDA, 16-sep-2015 14:03:30.
 * 
XXXX
 */

public interface ContratoViviendaService {

	/**
	 * Inserts a single row in the ContratoVivienda table.
	 * 
	 * @param contratoVivienda
	 *            ContratoVivienda
	 * @return ContratoVivienda
	 */
	ContratoVivienda add(ContratoVivienda contratoVivienda);

	/**
	 * Updates a single row in the ContratoVivienda table.
	 * 
	 * @param contratoVivienda
	 *            ContratoVivienda
	 * @return ContratoVivienda
	 */
	ContratoVivienda update(ContratoVivienda contratoVivienda);

	/**
	 * Finds a single row in the ContratoVivienda table.
	 * 
	 * @param contratoVivienda
	 *            ContratoVivienda
	 * @return ContratoVivienda
	 */
	ContratoVivienda find(ContratoVivienda contratoVivienda);

	/**
	 * Deletes a single row in the ContratoVivienda table.
	 * 
	 * @param contratoVivienda
	 *            ContratoVivienda
	 */
	void remove(ContratoVivienda contratoVivienda);

	/**
	 * Finds a list of rows in the ContratoVivienda table.
	 * 
	 * @param contratoVivienda
	 *            ContratoVivienda
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<ContratoVivienda>
	 */
	List<ContratoVivienda> findAll(ContratoVivienda contratoVivienda,
			JQGridRequestDto jqGridRequestDto);
	
	/**
	 * Finds a list of rows in the ContratoVivienda table.
	 * 
	 * @param contratoVivienda
	 *            ContratoVivienda
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<ContratoVivienda>
	 */
	List<ContratoVivienda> findAllSolPlatea(ContratoVivienda contratoVivienda,
	        JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the ContratoVivienda table using like.
	 * 
	 * @param contratoVivienda
	 *            ContratoVivienda
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<ContratoVivienda>
	 */
	List<ContratoVivienda> findAllLike(ContratoVivienda contratoVivienda,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Filter method in the ContratoVivienda table.
	 * 
	 * @param filterContratoVivienda
	 *            ContratoVivienda
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<ContratoVivienda>
	 */
	JQGridResponseDto<ContratoVivienda> filter(
			ContratoVivienda filterContratoVivienda,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Reorder the selection made in ContratoVivienda table.
	 * 
	 * @param filterContratoVivienda
	 *            ContratoVivienda
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return Object
	 */
	Object reorderSelection(ContratoVivienda filterContratoVivienda,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Funcion que valida si al visar un contrato se esta superando el importe
	 * maximo autorizado en la promocion.
	 * 
	 * @param numExpediente
	 *            String
	 * @param idVivienda
	 *            BigDecimal
	 * @return PlSqlOutputError
	 */
	PlSqlOutputError validarImporteAutorizado(String numExpediente,
			BigDecimal idVivienda);

	/**
	 * Funcion que busca si existe algun contrato de primera transmision para la
	 * vivienda seleccionada.
	 * 
	 * @param BigDecimal
	 *            numVivienda
	 * @return Long
	 */
	Long findContratoPrimerTrans(BigDecimal numVivienda);
}
