package com.ejie.m62fb.service.registroVPP;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.security.access.prepost.PreAuthorize;

import java.math.BigDecimal;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.ejie.m62fb.utils.constants.IberErrorsMsgConstants;
import com.ejie.m62fb.utils.error.UFException;
import com.ejie.m62fb.dao.registroVPP.ContratoViviendaDao;
import com.ejie.m62fb.model.ContratoVivienda;
import com.ejie.m62fb.model.plsql.PlSqlOutputError;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * ContratoViviendaServiceImpl generated by UDA, 16-sep-2015 14:03:30.
 * 
XXXX
 */

@Service(value = "contratoViviendaService")
public class ContratoViviendaServiceImpl implements ContratoViviendaService {

	@Autowired
	private ContratoViviendaDao contratoViviendaDao;

	/**
	 * Inserts a single row in the ContratoVivienda table.
	 * 
	 * @param contratoVivienda
	 *            ContratoVivienda
	 * @return ContratoVivienda
	 */
	@Override
	@Transactional(rollbackFor = Throwable.class)
@PreAuthorize("hasPermission('CONTRATO_VIVIENDA_SERVICE','SecureService','create')")
	public ContratoVivienda add(ContratoVivienda contratoVivienda) {
		// Comprobamos que no haya otro contrato con la misma fecha de contrato.
		// Si es que existe algún otro sacamos un mensaje de error. Si no
		// existe, se inserta en BBDD.
		boolean existe = this.contratoViviendaDao
				.findAllCountContratosVivienda(contratoVivienda);
		if (existe) {
			// Mensaje error
			throw new UFException(IberErrorsMsgConstants.CODE_CONTRATO_EXIST);
		} else {
			return this.contratoViviendaDao.add(contratoVivienda);
		}
	}

	/**
	 * Updates a single row in the ContratoVivienda table.
	 * 
	 * @param contratoVivienda
	 *            ContratoVivienda
	 * @return ContratoVivienda
	 */
	@Override
	@Transactional(rollbackFor = Throwable.class)
@PreAuthorize("hasPermission('CONTRATO_VIVIENDA_SERVICE','SecureService','write')")
	public ContratoVivienda update(ContratoVivienda contratoVivienda) {
		// find for update
		ContratoVivienda contratoViviendaBD = this.contratoViviendaDao
				.findForUpdate(contratoVivienda);
		// actualizar datos modificables
		contratoViviendaBD.getExpedienteVivienda().setNumExpediente(
				contratoVivienda.getExpedienteVivienda().getNumExpediente());
		contratoViviendaBD.setFecEntContrato(contratoVivienda
				.getFecEntContrato());
		contratoViviendaBD.setFecTransmision(contratoVivienda
				.getFecTransmision());
		contratoViviendaBD.setFecEscritura(contratoVivienda.getFecEscritura());
		contratoViviendaBD.setFecEmpadron(contratoVivienda.getFecEmpadron());
		contratoViviendaBD.setDireccion(contratoVivienda.getDireccion());
		contratoViviendaBD.setTipoTransmision(contratoVivienda
				.getTipoTransmision());
		contratoViviendaBD.setIndVisado(contratoVivienda.getIndVisado());
		contratoViviendaBD.setFecVisado(contratoVivienda.getFecVisado());
		contratoViviendaBD.setIndRenuncia(contratoVivienda.getIndRenuncia());
		contratoViviendaBD.setFecRenuncia(contratoVivienda.getFecRenuncia());
		contratoViviendaBD
				.setIndRevocacion(contratoVivienda.getIndRevocacion());
		contratoViviendaBD
				.setFecRevocacion(contratoVivienda.getFecRevocacion());
		contratoViviendaBD.setTexObservaciones(contratoVivienda
				.getTexObservaciones());

		// Comprobamos que no haya otro contrato con la misma fecha de contrato.
		// Si es que existe algún otro sacamos un mensaje de error. Si no
		// existe, se actualiza en BBDD.
		boolean existe = this.contratoViviendaDao
				.findAllCountContratosVivienda(contratoViviendaBD);
		if (existe) {
			// Mensaje error
			throw new UFException(IberErrorsMsgConstants.CODE_CONTRATO_EXIST);
		} else {
			// Actualiza en BBDD
			return this.contratoViviendaDao.update(contratoViviendaBD);
		}
	}

	/**
	 * Finds a single row in the ContratoVivienda table.
	 * 
	 * @param contratoVivienda
	 *            ContratoVivienda
	 * @return ContratoVivienda
	 */
	@Override
@PreAuthorize("hasPermission('CONTRATO_VIVIENDA_SERVICE','SecureService','read')")
	public ContratoVivienda find(ContratoVivienda contratoVivienda) {
		return this.contratoViviendaDao.find(contratoVivienda);
	}

	/**
	 * Deletes a single row in the ContratoVivienda table.
	 * 
	 * @param contratoVivienda
	 *            ContratoVivienda
	 */
	@Override
	@Transactional(rollbackFor = Throwable.class)
@PreAuthorize("hasPermission('CONTRATO_VIVIENDA_SERVICE','SecureService','delete')")
	public void remove(ContratoVivienda contratoVivienda) {
		this.contratoViviendaDao.remove(contratoVivienda);
	}

	/**
	 * Finds a list of rows in the ContratoVivienda table.
	 * 
	 * @param contratoVivienda
	 *            ContratoVivienda
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<ContratoVivienda>
	 */
	@Override
@PreAuthorize("hasPermission('CONTRATO_VIVIENDA_SERVICE','SecureService','read')")
	public List<ContratoVivienda> findAll(ContratoVivienda contratoVivienda,
			JQGridRequestDto jqGridRequestDto) {
		return this.contratoViviendaDao.findAll(contratoVivienda,
				jqGridRequestDto);
	}
	
	/**
	 * Finds a list of rows in the ContratoVivienda table.
	 * 
	 * @param contratoVivienda
	 *            ContratoVivienda
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<ContratoVivienda>
	 */
	@Override
	@PreAuthorize("hasPermission('CONTRATO_VIVIENDA_SERVICE','SecureService','read')")
	public List<ContratoVivienda> findAllSolPlatea(ContratoVivienda contratoVivienda,
	        JQGridRequestDto jqGridRequestDto) {
	    return this.contratoViviendaDao.findAllSolPlatea(contratoVivienda,
	            jqGridRequestDto);
	}

	/**
	 * Finds rows in the ContratoVivienda table using like.
	 * 
	 * @param contratoVivienda
	 *            ContratoVivienda
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<ContratoVivienda>
	 */
	@Override
@PreAuthorize("hasPermission('CONTRATO_VIVIENDA_SERVICE','SecureService','read')")
	public List<ContratoVivienda> findAllLike(
			ContratoVivienda contratoVivienda,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		return this.contratoViviendaDao.findAllLike(contratoVivienda,
				jqGridRequestDto, startsWith);
	}

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Filter method in the ContratoVivienda table.
	 * 
	 * @param filterContratoVivienda
	 *            ContratoVivienda
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<ContratoVivienda>
	 */
	@Override
@PreAuthorize("hasPermission('CONTRATO_VIVIENDA_SERVICE','SecureService','read')")
	public JQGridResponseDto<ContratoVivienda> filter(
			ContratoVivienda filterContratoVivienda,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		List<ContratoVivienda> listaContratoVivienda = this.contratoViviendaDao
				.findAllLike(filterContratoVivienda, jqGridRequestDto, false);
		Long recordNum = this.contratoViviendaDao.findAllLikeCount(
				filterContratoVivienda != null ? filterContratoVivienda
						: new ContratoVivienda(), false);
		if (jqGridRequestDto.getMultiselection().getSelectedIds() != null) {
			List<TableRowDto<ContratoVivienda>> reorderSelection = this.contratoViviendaDao
					.reorderSelection(filterContratoVivienda, jqGridRequestDto,
							startsWith);
			return new JQGridResponseDto<ContratoVivienda>(jqGridRequestDto,
					recordNum, listaContratoVivienda, reorderSelection);
		}
		return new JQGridResponseDto<ContratoVivienda>(jqGridRequestDto,
				recordNum, listaContratoVivienda);
	}

	/**
	 * Reorder the selection made in ContratoVivienda table.
	 * 
	 * @param filterContratoVivienda
	 *            ContratoVivienda
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return Object
	 */
	@Override
@PreAuthorize("hasPermission('CONTRATO_VIVIENDA_SERVICE','SecureService','read')")
	public Object reorderSelection(ContratoVivienda filterContratoVivienda,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		return this.contratoViviendaDao.reorderSelection(
				filterContratoVivienda, jqGridRequestDto, startsWith);
	}

	/**
	 * Funcion que valida si al visar un contrato se esta superando el importe
	 * maximo autorizado en la promocion.
	 * 
	 * @param numExpediente
	 *            String
	 * @param idVivienda
	 *            BigDecimal
	 * @return PlSqlOutputError
	 */
	@Override
	@Transactional(rollbackFor = Throwable.class)
	public PlSqlOutputError validarImporteAutorizado(String numExpediente,
			BigDecimal idVivienda) {
		return this.contratoViviendaDao.validarImporteAutorizado(numExpediente,
				idVivienda);
	}

	/**
	 * Funcion que busca si existe algun contrato de primera transmision para la
	 * vivienda seleccionada.
	 * 
	 * @param BigDecimal
	 *            numVivienda
	 * @return Long
	 */
	@Override
	@Transactional(rollbackFor = Throwable.class)
	public Long findContratoPrimerTrans(BigDecimal numVivienda) {
		return this.contratoViviendaDao.findContratoPrimerTrans(numVivienda);
	}
}
