package com.ejie.m62fb.service.registroVPP;
import org.springframework.security.access.prepost.PreAuthorize;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.ejie.m62fb.dao.registroVPP.ExpedienteSancionadorDao;
import com.ejie.m62fb.model.ExpedienteSancionador;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;

/**
 * ExpedienteSancionadorServiceImpl generated by UDA, 12-nov-2015 17:14:31.
 * 
XXXX
 */

@Service(value = "expedienteSancionadorService")
public class ExpedienteSancionadorServiceImpl implements
		ExpedienteSancionadorService {

	@Autowired
	private ExpedienteSancionadorDao expedienteSancionadorDao;

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Filter method in the ExpedienteSancionador table.
	 * 
	 * @param filterExpedienteSancionador
	 *            ExpedienteSancionador
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<ExpedienteSancionador>
	 */
	@Override
@PreAuthorize("hasPermission('EXPEDIENTE_SANCIONADOR_SERVICE','SecureService','read')")
	public JQGridResponseDto<ExpedienteSancionador> filter(
			ExpedienteSancionador filterExpedienteSancionador,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		List<ExpedienteSancionador> listaExpedienteSancionador = this.expedienteSancionadorDao
				.findAllLike(filterExpedienteSancionador, jqGridRequestDto,
						false);
		Long recordNum = this.expedienteSancionadorDao
				.findAllLikeCount(
						filterExpedienteSancionador != null ? filterExpedienteSancionador
								: new ExpedienteSancionador(), false);
		return new JQGridResponseDto<ExpedienteSancionador>(jqGridRequestDto,
				recordNum, listaExpedienteSancionador);
	}
}
