package com.ejie.m62fb.service.registroVPP;
import org.springframework.security.access.prepost.PreAuthorize;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.ejie.m62fb.dao.registroVPP.ExpedienteViviendaDao;
import com.ejie.m62fb.model.ExpedienteVivienda;

/**
 * ExpedienteViviendaServiceImpl generated by UDA, 29-sep-2015 12:03:30.
 * 
XXXX
 */

@Service(value = "expedienteViviendaService")
public class ExpedienteViviendaServiceImpl implements ExpedienteViviendaService {

	@Autowired
	private ExpedienteViviendaDao expedienteViviendaDao;

	/**
	 * Devuelve el numero de Expediente de la tabla M62R02S00 (buscamos por
	 * NUM_VIVIENDA y obtenemos el primer registro con mayor NUM_ORDEN)
	 * 
	 * @param idVivienda
	 *            Integer
	 * @return ExpedienteVivienda
	 */
	@Override
	@Transactional(rollbackFor = Throwable.class)
@PreAuthorize("hasPermission('EXPEDIENTE_VIVIENDA_SERVICE','SecureService','read')")
	public ExpedienteVivienda findExpedienteVivienda(Integer idVivienda) {
		return this.expedienteViviendaDao.findExpedienteVivienda(idVivienda);
	}
}
