package com.ejie.m62fb.service.registroVPP;

import java.util.List;

import com.ejie.m62fb.model.SolicitudReserva;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;

/**
 * SolicitudesReservaService.
 * 
XXXX
 */
public interface SolicitudReservaService {

	/**
	 * Guarda una nueva Solicitud Reserva y sus Viviendas Solicitadas
	 * 
	 * @param solicitudReserva
	 *            SolicitudReserva
	 */
	void guardarSolicitudReserva(SolicitudReserva solicitudReserva);

	/**
	 * Actualiza el estado de la solicitud a "APERTURADO(2)" e informa el
	 * numExpedientePlatea introducido en la apertura
	 * 
	 * @param solicitudReserva
	 *            SolicitudReserva(idExpedientePlatea(folderId),
	 *            numExpedientePlatea(folderNumber))
	 */
	void updateEstadoApertura(SolicitudReserva solicitudReserva);

	/**
	 * Actualiza el estado de la solicitud a "NOTIFICADO(3)"
	 * 
	 * @param solicitudReserva
	 *            SolicitudReserva(idExpedientePlatea(folderId))
	 */
	void updateEstadoNotificacion(SolicitudReserva solicitudReserva);

	/**
	 * Finds a single row in the SolicitudReserva table.
	 * 
	 * @param solicitudReserva
	 *            SolicitudReserva
	 * @return SolicitudReserva
	 */
	SolicitudReserva find(SolicitudReserva solicitudReserva);

	/**
	 * Finds a list of rows in the SolicitudReserva table.
	 * 
	 * @param solicitudReserva
	 *            SolicitudReserva
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<SolicitudReserva>
	 */
	List<SolicitudReserva> findAll(SolicitudReserva solicitudReserva,
			JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the SolicitudReserva table using like.
	 * 
	 * @param solicitudReserva
	 *            SolicitudReserva
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<SolicitudReserva>
	 */
	List<SolicitudReserva> findAllLike(SolicitudReserva solicitudReserva,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Filter method in the SolicitudReserva table.
	 * 
	 * @param filterSolicitudesReserva
	 *            SolicitudReserva
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<SolicitudReserva>
	 */
	JQGridResponseDto<SolicitudReserva> filter(
			SolicitudReserva filterSolicitudesReserva,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);
}