package com.ejie.m62fb.service.registroVPP;

import java.util.List;

import com.ejie.m62fb.model.ViviendaSolicitada;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;

/**
 * ViviendasSolicitadasService.
 * 
XXXX
 */
public interface ViviendaSolicitadaService {

	/**
	 * Inserts a single row in the ViviendaSolicitada table.
	 * 
	 * @param viviendaSolicitada
	 *            ViviendaSolicitada
	 * @return ViviendaSolicitada
	 */
	ViviendaSolicitada add(ViviendaSolicitada viviendaSolicitada);

	/**
	 * Finds a single row in the ViviendaSolicitada table.
	 * 
	 * @param viviendaSolicitada
	 *            ViviendaSolicitada
	 * @return ViviendaSolicitada
	 */
	ViviendaSolicitada find(ViviendaSolicitada viviendaSolicitada);

	/**
	 * Finds a list of rows in the ViviendaSolicitada table.
	 * 
	 * @param viviendaSolicitada
	 *            ViviendaSolicitada
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<ViviendaSolicitada>
	 */
	List<ViviendaSolicitada> findAll(ViviendaSolicitada viviendaSolicitada,
			JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the ViviendaSolicitada table using like.
	 * 
	 * @param viviendaSolicitada
	 *            ViviendaSolicitada
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<ViviendaSolicitada>
	 */
	List<ViviendaSolicitada> findAllLike(ViviendaSolicitada viviendaSolicitada,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Filter method in the ViviendaSolicitada table.
	 * 
	 * @param filterViviendaSolicitada
	 *            ViviendaSolicitada
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<ViviendaSolicitada>
	 */
	JQGridResponseDto<ViviendaSolicitada> filter(
			ViviendaSolicitada filterViviendaSolicitada,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);
}