/**
 * 
 */
package com.ejie.m62fb.utils.sql;

/**
 * <p>
 * Clase para indicar si hay que implementar el operador <code>LIKE</code> en la 
 * <code>WHERE</code> y c&oacute;mo hay que hacerlo.
 * </p>
 * 
XXXX
 *
 */
public class LikeInWhere {

	/**
	 * <p>Indica si hay que implementar el operador <code>LIKE</code> en la 
	 * <code>WHERE</code> <code>true</code>) o no (<code>false</code>).</p>
	 */
	private boolean implementar;
	/**
	 * <p>Indica si en los campos de texto se buscar&aacute;n registros que empiezen
	 * (<code>true</code>) o contengan (<code>false</code>) el criterio.</p>
	 */
	private boolean startsWith;
	
	/**
	 *<p>Constructor por defecto.</p> 
	 */
	public LikeInWhere() {
		this.implementar = false;
		this.startsWith = false;
	}

	/**
	 * <p>Constructor con los valores de la clase para inicializarlos.</p>
	 * 
	 * @param implementar El valor que indica si hay que implementar el operador <code>LIKE</code>.
	 * @param startsWith El valor que indica como se comparan los registros.
	 */
	public LikeInWhere(final boolean implementar,final boolean startsWith) {
		super();
		this.implementar = implementar;
		this.startsWith = startsWith;
	}

	/**
	 * <p>Devuelve el valor que indica si hay que implementar el operador
	 *  <code>LIKE</code> en la <code>WHERE</code> <code>true</code>) o no (<code>false</code>).
	 * </p>
	 * @return El valor que indica si hay que implementar el operador <code>LIKE</code>
	 */
	public boolean isImplementar() {
		return implementar;
	}

	
	/**
	 *<p>Establece el valor que indica si hay que implementar el operador
	 *  <code>LIKE</code> en la <code>WHERE</code> <code>true</code>) o no (<code>false</code>).
	 * </p>
	 * @param implementar El valor que indica si hay que implementar el operador <code>LIKE</code>
	 */
	public void setImplementar(final boolean implementar) {
		this.implementar = implementar;
	}

	/**
	 * <p>Devuelve el valor que indica si en los campos de texto se buscar&aacute;n registros que empiezen
	 * (<code>true</code>) o contengan (<code>false</code>) el criterio.
	 * </p>
	 * @return El valor que indica como se comparan los registros
	 */
	public boolean isStartsWith() {
		return startsWith;
	}

	/**
	 * <p>Establece el valor que indica si en los campos de texto se buscar&aacute;n registros que empiezen
	 * (<code>true</code>) o contengan (<code>false</code>) el criterio.
	 * </p>
	 * @param startsWith El valor que indica como se comparan los registros
	 */
	public void setStartsWith(final boolean startsWith) {
		this.startsWith = startsWith;
	}

}
