package com.ejie.m62fb.control;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Locale;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.bind.annotation.ResponseStatus;

import com.ejie.m62fb.model.M62fbRegAcceso;
import com.ejie.m62fb.service.M62fbRegAccesoService;
import com.ejie.x38.control.exception.ResourceNotFoundException;
import com.ejie.x38.dto.JQGridJSONModel;
import com.ejie.x38.dto.Pagination;
import com.ejie.x38.util.ObjectConversionManager;

/**
 * M62fbRegAccesoController generated by UDA, 24-oct-2012 16:48:56.
 * 
XXXX
 */

@Controller
@RequestMapping(value = "/m62fbregacceso")
public class M62fbRegAccesoController {

	private static final Logger logger = LoggerFactory
			.getLogger(M62fbRegAccesoController.class);

	@Autowired
	private M62fbRegAccesoService m62fbRegAccesoService;

	/**
	 * Method 'getCreateForm'.
	 * 
	 * @param model
	 *            Model
	 * @return String
	 */
	@RequestMapping(value = "maint", method = RequestMethod.GET)
	public String getCreateForm(Model model) {
		M62fbRegAccesoController.logger.info("[GET - View] : m62fbregacceso");
		return "m62fbregacceso";
	}

	/**
	 * Method 'getSituaciones'.
	 * 
	 * @param id
	 *            String
	 * @param dsO
	 *            String
	 * @param autonomiaId
	 *            String
	 * @param request
	 *            HttpServletRequest
	 * @return String
	 */
	@RequestMapping(value = "tiposdeacceso", method = RequestMethod.GET)
	public @ResponseBody
	List<HashMap<String, String>> getAccesos(Locale locale) {
		try {
			// M62fbProvincias filterProvincia = new M62fbProvincias(id, dsO);
			List<M62fbRegAcceso> tiposDeAcceso = this.m62fbRegAccesoService
					.findAll(null, null);
			if (tiposDeAcceso == null) {
				throw new Exception("No data Found.");
			}
			ArrayList<HashMap<String, String>> returnData = new ArrayList<HashMap<String, String>>();
			HashMap<String, String> opc = new HashMap<String, String>();
			Iterator modelosIter = tiposDeAcceso.iterator();
			while (modelosIter.hasNext()) {
				M62fbRegAcceso modelObject = (M62fbRegAcceso) modelosIter
						.next();
				opc.put("value", modelObject.getCodTabla());
				opc.put("label",
						modelObject.getDesTablaCas().get(locale.getLanguage()));
				returnData.add(opc);
				opc = new HashMap<String, String>();
			}
			return returnData;
		} catch (Exception e) {
			throw new ResourceNotFoundException("No data Found.");
		}
	}

	/**
	 * Method 'getById'.
	 * 
	 * @param codTabla
	 *            String
	 * @param desTablaCas
	 *            String
	 * @return m62fbRegAcceso M62fbRegAcceso
	 */
	@RequestMapping(value = "/{codTabla}", method = RequestMethod.GET)
	public @ResponseBody
	M62fbRegAcceso getById(@PathVariable String codTabla,
			@PathVariable String desTablaCas) {
		M62fbRegAcceso m62fbRegAcceso = new M62fbRegAcceso();
		m62fbRegAcceso.setCodTabla(codTabla);
		// m62fbRegAcceso.setDesTablaCas(desTablaCas);
		m62fbRegAcceso = this.m62fbRegAccesoService.find(m62fbRegAcceso);
		M62fbRegAccesoController.logger
				.info("[GET - findBy_PK] : Obtener M62fbRegAcceso por PK");
		return m62fbRegAcceso;
	}

	/**
	 * Method 'getAll'.
	 * 
	 * @param filterM62fbRegAcceso
	 *            M62fbRegAcceso
	 * @return List
	 */
	@RequestMapping(method = RequestMethod.GET)
	public @ResponseBody
	List<M62fbRegAcceso> getAll(
			@ModelAttribute M62fbRegAcceso filterM62fbRegAcceso) {
		M62fbRegAccesoController.logger
				.info("[GET - find_ALL] : Obtener M62fbRegAcceso por filtro");
		return this.m62fbRegAccesoService.findAll(filterM62fbRegAcceso, null);
	}

	/**
	 * Method 'edit'.
	 * 
	 * @param m62fbRegAcceso
	 *            M62fbRegAcceso
	 * @return M62fbRegAcceso
	 */
	@RequestMapping(method = RequestMethod.PUT)
	public @ResponseBody
	M62fbRegAcceso edit(@RequestBody M62fbRegAcceso m62fbRegAcceso) {
		M62fbRegAcceso m62fbRegAccesoAux = this.m62fbRegAccesoService
				.update(m62fbRegAcceso);
		M62fbRegAccesoController.logger
				.info("[PUT] : M62fbRegAcceso actualizado correctamente");
		return m62fbRegAccesoAux;
	}

	/**
	 * Method 'add'.
	 * 
	 * @param m62fbRegAcceso
	 *            M62fbRegAcceso
	 * @return M62fbRegAcceso
	 */
	@RequestMapping(method = RequestMethod.POST)
	public @ResponseBody
	M62fbRegAcceso add(@RequestBody M62fbRegAcceso m62fbRegAcceso) {
		M62fbRegAcceso m62fbRegAccesoAux = this.m62fbRegAccesoService
				.add(m62fbRegAcceso);
		M62fbRegAccesoController.logger
				.info("[POST] : M62fbRegAcceso insertado correctamente");
		return m62fbRegAccesoAux;
	}

	/**
	 * Method 'remove'.
	 * 
	 * @param codTabla
	 *            String
	 * @param desTablaCas
	 *            String
	 * @return m62fbRegAcceso
	 */
	@RequestMapping(value = "/{codTabla}/{desTablaCas}", method = RequestMethod.DELETE)
	@ResponseStatus(value = HttpStatus.OK)
	public @ResponseBody
	M62fbRegAcceso remove(@PathVariable String codTabla,
			@PathVariable String desTablaCas) {
		M62fbRegAcceso m62fbRegAcceso = new M62fbRegAcceso();
		m62fbRegAcceso.setCodTabla(codTabla);
		// m62fbRegAcceso.setDesTablaCas(desTablaCas);
		this.m62fbRegAccesoService.remove(m62fbRegAcceso);
		M62fbRegAccesoController.logger
				.info("[DELETE] : M62fbRegAcceso borrado correctamente");
		return m62fbRegAcceso;
	}

	/**
	 * Method 'removeAll'.
	 * 
	 * @param m62fbRegAccesoIds
	 *            List
	 * @return m62fbRegAccesoList
	 */
	@RequestMapping(value = "/deleteAll", method = RequestMethod.POST)
	@ResponseStatus(value = HttpStatus.OK)
	public @ResponseBody
	List<List<String>> removeMultiple(
			@RequestBody List<List<String>> m62fbRegAccesoIds) {
		List<M62fbRegAcceso> m62fbRegAccesoList = new ArrayList<M62fbRegAcceso>();
		for (List<String> m62fbRegAccesoId : m62fbRegAccesoIds) {
			Iterator<String> iterator = m62fbRegAccesoId.iterator();
			M62fbRegAcceso m62fbRegAcceso = new M62fbRegAcceso(); // NOPMD -
																	// Objeto
																	// nuevo en
																	// la lista
																	// (parametro
																	// del
																	// servicio)
			m62fbRegAcceso.setCodTabla(ObjectConversionManager.convert(
					iterator.next(), String.class));
			/*
			 * m62fbRegAcceso.setDesTablaCas(ObjectConversionManager.convert(
			 * iterator.next(), String.class));
			 */
			m62fbRegAccesoList.add(m62fbRegAcceso);
		}
		this.m62fbRegAccesoService.removeMultiple(m62fbRegAccesoList);
		M62fbRegAccesoController.logger
				.info("[POST - DELETE_ALL] : M62fbRegAcceso borrados correctamente");
		return m62fbRegAccesoIds;
	}

	/**
	 * Method 'getAllJQGrid'.
	 * 
	 * @param filterM62fbRegAcceso
	 *            M62fbRegAcceso
	 * @param pagination
	 *            Pagination
	 * @return JQGridJSONModel
	 */
	@RequestMapping(method = RequestMethod.GET, headers = { "JQGridModel=true" })
	public @ResponseBody
	JQGridJSONModel getAllJQGrid(
			@ModelAttribute M62fbRegAcceso filterM62fbRegAcceso,
			@ModelAttribute Pagination pagination) {
		List<M62fbRegAcceso> m62fbRegAccesos = this.m62fbRegAccesoService
				.findAll(filterM62fbRegAcceso, pagination);
		Long recordNum = this.m62fbRegAccesoService
				.findAllCount(filterM62fbRegAcceso);
		M62fbRegAccesoController.logger
				.info("[GET - jqGrid] : Obtener M62fbRegAcceso");
		return new JQGridJSONModel(pagination, recordNum, m62fbRegAccesos);
	}

}
