package com.ejie.m62fb.control;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Locale;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.bind.annotation.ResponseStatus;

import com.ejie.m62fb.model.M62fbRegTenencia;
import com.ejie.m62fb.service.M62fbRegTenenciaService;
import com.ejie.x38.control.exception.ResourceNotFoundException;
import com.ejie.x38.dto.JQGridJSONModel;
import com.ejie.x38.dto.Pagination;
import com.ejie.x38.util.ObjectConversionManager;

/**
 * M62fbRegTenenciaController generated by UDA, 19-nov-2012 13:36:52.
 * 
XXXX
 */

@Controller
@RequestMapping(value = "/m62fbregtenencia")
public class M62fbRegTenenciaController {

	private static final Logger logger = LoggerFactory
			.getLogger(M62fbRegTenenciaController.class);

	@Autowired
	private M62fbRegTenenciaService m62fbRegTenenciaService;

	/**
	 * Method 'getCreateForm'.
	 * 
	 * @param model
	 *            Model
	 * @return String
	 */
	@RequestMapping(value = "maint", method = RequestMethod.GET)
	public String getCreateForm(Model model) {
		M62fbRegTenenciaController.logger
				.info("[GET - View] : m62fbregtenencia");
		return "m62fbregtenencia";
	}

	/**
	 * Method 'getSituaciones'.
	 * 
	 * @param id
	 *            String
	 * @param dsO
	 *            String
	 * @param autonomiaId
	 *            String
	 * @param request
	 *            HttpServletRequest
	 * @return String
	 */
	@RequestMapping(value = "tiposdetenencia", method = RequestMethod.GET)
	public @ResponseBody
	List<HashMap<String, String>> getAccesos(Locale locale) {
		try {
			// M62fbProvincias filterProvincia = new M62fbProvincias(id, dsO);
			List<M62fbRegTenencia> tiposDeTenencia = this.m62fbRegTenenciaService
					.findAll(null, null);
			if (tiposDeTenencia == null) {
				throw new Exception("No data Found.");
			}
			ArrayList<HashMap<String, String>> returnData = new ArrayList<HashMap<String, String>>();
			HashMap<String, String> opc = new HashMap<String, String>();
			Iterator modelosIter = tiposDeTenencia.iterator();
			while (modelosIter.hasNext()) {
				M62fbRegTenencia modelObject = (M62fbRegTenencia) modelosIter
						.next();
				opc.put("value", modelObject.getCodTabla());
				opc.put("label",
						modelObject.getDesTabla().get(locale.getLanguage()));
				returnData.add(opc);
				opc = new HashMap<String, String>();
			}
			return returnData;
		} catch (Exception e) {
			throw new ResourceNotFoundException("No data Found.");
		}
	}

	/**
	 * Method 'getById'.
	 * 
	 * @param codTabla
	 *            String
	 * @param desTablaCas
	 *            String
	 * @return m62fbRegTenencia M62fbRegTenencia
	 */
	@RequestMapping(value = "/{codTabla}", method = RequestMethod.GET)
	public @ResponseBody
	M62fbRegTenencia getById(@PathVariable String codTabla,
			@PathVariable String desTablaCas) {
		M62fbRegTenencia m62fbRegTenencia = new M62fbRegTenencia();
		m62fbRegTenencia.setCodTabla(codTabla);
		// m62fbRegTenencia.setDesTabla(desTablaCas);
		m62fbRegTenencia = this.m62fbRegTenenciaService.find(m62fbRegTenencia);
		M62fbRegTenenciaController.logger
				.info("[GET - findBy_PK] : Obtener M62fbRegTenencia por PK");
		return m62fbRegTenencia;
	}

	/**
	 * Method 'getAll'.
	 * 
	 * @param filterM62fbRegTenencia
	 *            M62fbRegTenencia
	 * @return List
	 */
	@RequestMapping(method = RequestMethod.GET)
	public @ResponseBody
	List<M62fbRegTenencia> getAll(
			@ModelAttribute M62fbRegTenencia filterM62fbRegTenencia) {
		M62fbRegTenenciaController.logger
				.info("[GET - find_ALL] : Obtener M62fbRegTenencia por filtro");
		return this.m62fbRegTenenciaService.findAll(filterM62fbRegTenencia,
				null);
	}

	/**
	 * Method 'edit'.
	 * 
	 * @param m62fbRegTenencia
	 *            M62fbRegTenencia
	 * @return M62fbRegTenencia
	 */
	@RequestMapping(method = RequestMethod.PUT)
	public @ResponseBody
	M62fbRegTenencia edit(@RequestBody M62fbRegTenencia m62fbRegTenencia) {
		M62fbRegTenencia m62fbRegTenenciaAux = this.m62fbRegTenenciaService
				.update(m62fbRegTenencia);
		M62fbRegTenenciaController.logger
				.info("[PUT] : M62fbRegTenencia actualizado correctamente");
		return m62fbRegTenenciaAux;
	}

	/**
	 * Method 'add'.
	 * 
	 * @param m62fbRegTenencia
	 *            M62fbRegTenencia
	 * @return M62fbRegTenencia
	 */
	@RequestMapping(method = RequestMethod.POST)
	public @ResponseBody
	M62fbRegTenencia add(@RequestBody M62fbRegTenencia m62fbRegTenencia) {
		M62fbRegTenencia m62fbRegTenenciaAux = this.m62fbRegTenenciaService
				.add(m62fbRegTenencia);
		M62fbRegTenenciaController.logger
				.info("[POST] : M62fbRegTenencia insertado correctamente");
		return m62fbRegTenenciaAux;
	}

	/**
	 * Method 'remove'.
	 * 
	 * @param codTabla
	 *            String
	 * @param desTablaCas
	 *            String
	 * @return m62fbRegTenencia
	 */
	@RequestMapping(value = "/{codTabla}", method = RequestMethod.DELETE)
	@ResponseStatus(value = HttpStatus.OK)
	public @ResponseBody
	M62fbRegTenencia remove(@PathVariable String codTabla,
			@PathVariable String desTablaCas) {
		M62fbRegTenencia m62fbRegTenencia = new M62fbRegTenencia();
		m62fbRegTenencia.setCodTabla(codTabla);
		// m62fbRegTenencia.setDesTablaCas(desTablaCas);
		this.m62fbRegTenenciaService.remove(m62fbRegTenencia);
		M62fbRegTenenciaController.logger
				.info("[DELETE] : M62fbRegTenencia borrado correctamente");
		return m62fbRegTenencia;
	}

	/**
	 * Method 'removeAll'.
	 * 
	 * @param m62fbRegTenenciaIds
	 *            List
	 * @return m62fbRegTenenciaList
	 */
	@RequestMapping(value = "/deleteAll", method = RequestMethod.POST)
	@ResponseStatus(value = HttpStatus.OK)
	public @ResponseBody
	List<List<String>> removeMultiple(
			@RequestBody List<List<String>> m62fbRegTenenciaIds) {
		List<M62fbRegTenencia> m62fbRegTenenciaList = new ArrayList<M62fbRegTenencia>();
		for (List<String> m62fbRegTenenciaId : m62fbRegTenenciaIds) {
			Iterator<String> iterator = m62fbRegTenenciaId.iterator();
			M62fbRegTenencia m62fbRegTenencia = new M62fbRegTenencia(); // NOPMD
																		// -
																		// Objeto
																		// nuevo
																		// en la
																		// lista
																		// (parametro
																		// del
																		// servicio)
			m62fbRegTenencia.setCodTabla(ObjectConversionManager.convert(
					iterator.next(), String.class));
			/*
			 * m62fbRegTenencia.setDesTabla(ObjectConversionManager.convert(
			 * iterator.next(), String.class));
			 */
			m62fbRegTenenciaList.add(m62fbRegTenencia);
		}
		this.m62fbRegTenenciaService.removeMultiple(m62fbRegTenenciaList);
		M62fbRegTenenciaController.logger
				.info("[POST - DELETE_ALL] : M62fbRegTenencia borrados correctamente");
		return m62fbRegTenenciaIds;
	}

	/**
	 * Method 'getAllJQGrid'.
	 * 
	 * @param filterM62fbRegTenencia
	 *            M62fbRegTenencia
	 * @param pagination
	 *            Pagination
	 * @return JQGridJSONModel
	 */
	@RequestMapping(method = RequestMethod.GET, headers = { "JQGridModel=true" })
	public @ResponseBody
	JQGridJSONModel getAllJQGrid(
			@ModelAttribute M62fbRegTenencia filterM62fbRegTenencia,
			@ModelAttribute Pagination pagination) {
		List<M62fbRegTenencia> m62fbRegTenencias = this.m62fbRegTenenciaService
				.findAll(filterM62fbRegTenencia, pagination);
		Long recordNum = this.m62fbRegTenenciaService
				.findAllCount(filterM62fbRegTenencia);
		M62fbRegTenenciaController.logger
				.info("[GET - jqGrid] : Obtener M62fbRegTenencia");
		return new JQGridJSONModel(pagination, recordNum, m62fbRegTenencias);
	}

}
