package com.ejie.m62fb.control;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Locale;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.bind.annotation.ResponseStatus;

import com.ejie.m62fb.model.M62fbSituacionViv;
import com.ejie.m62fb.service.M62fbSituacionVivService;
import com.ejie.x38.control.exception.ResourceNotFoundException;
import com.ejie.x38.dto.JQGridJSONModel;
import com.ejie.x38.dto.Pagination;
import com.ejie.x38.util.ObjectConversionManager;

/**
 * M62fbSituacionVivController generated by UDA, 24-oct-2012 16:48:56.
 * 
XXXX
 */

@Controller
@RequestMapping(value = "/m62fbsituacionviv")
public class M62fbSituacionVivController {

	private static final Logger logger = LoggerFactory
			.getLogger(M62fbSituacionVivController.class);

	@Autowired
	private M62fbSituacionVivService m62fbSituacionVivService;

	/**
	 * Method 'getCreateForm'.
	 * 
	 * @param model
	 *            Model
	 * @return String
	 */
	@RequestMapping(value = "maint", method = RequestMethod.GET)
	public String getCreateForm(Model model) {
		M62fbSituacionVivController.logger
				.info("[GET - View] : m62fbsituacionviv");
		return "m62fbsituacionviv";
	}

	/**
	 * Method 'getSituaciones'.
	 * 
	 * @param id
	 *            String
	 * @param dsO
	 *            String
	 * @param autonomiaId
	 *            String
	 * @param request
	 *            HttpServletRequest
	 * @return String
	 */
	@RequestMapping(value = "tiposdesituacion", method = RequestMethod.GET)
	public @ResponseBody
	List<HashMap<String, String>> getTiposDeSituacion(Locale locale) {
		try {
			// M62fbProvincias filterProvincia = new M62fbProvincias(id, dsO);
			List<M62fbSituacionViv> tiposDeSituacion = this.m62fbSituacionVivService
					.findAll(null, null);
			if (tiposDeSituacion == null) {
				throw new Exception("No data Found.");
			}
			ArrayList<HashMap<String, String>> returnData = new ArrayList<HashMap<String, String>>();
			HashMap<String, String> opc = new HashMap<String, String>();
			Iterator modelosIter = tiposDeSituacion.iterator();
			while (modelosIter.hasNext()) {
				M62fbSituacionViv modelObject = (M62fbSituacionViv) modelosIter
						.next();
				opc.put("value", modelObject.getCodTabla());
				opc.put("label",
						modelObject.getDesTabla().get(locale.getLanguage()));
				returnData.add(opc);
				opc = new HashMap<String, String>();
			}
			return returnData;

		} catch (Exception e) {
			throw new ResourceNotFoundException("No data Found.");
		}
	}

	/**
	 * Method 'getById'.
	 * 
	 * @param codTabla
	 *            String
	 * @param desTablaCas
	 *            String
	 * @return m62fbSituacionViv M62fbSituacionViv
	 */
	@RequestMapping(value = "/{codTabla}", method = RequestMethod.GET)
	public @ResponseBody
	M62fbSituacionViv getById(@PathVariable String codTabla,
			@PathVariable String desTablaCas) {
		M62fbSituacionViv m62fbSituacionViv = new M62fbSituacionViv();
		m62fbSituacionViv.setCodTabla(codTabla);
		// m62fbSituacionViv.setDesTabla(desTablaCas)
		m62fbSituacionViv = this.m62fbSituacionVivService
				.find(m62fbSituacionViv);
		M62fbSituacionVivController.logger
				.info("[GET - findBy_PK] : Obtener M62fbSituacionViv por PK");
		return m62fbSituacionViv;
	}

	/**
	 * Method 'getAll'.
	 * 
	 * @param filterM62fbSituacionViv
	 *            M62fbSituacionViv
	 * @return List
	 */
	@RequestMapping(method = RequestMethod.GET)
	public @ResponseBody
	List<M62fbSituacionViv> getAll(
			@ModelAttribute M62fbSituacionViv filterM62fbSituacionViv) {
		M62fbSituacionVivController.logger
				.info("[GET - find_ALL] : Obtener M62fbSituacionViv por filtro");
		return this.m62fbSituacionVivService.findAll(filterM62fbSituacionViv,
				null);
	}

	/**
	 * Method 'edit'.
	 * 
	 * @param m62fbSituacionViv
	 *            M62fbSituacionViv
	 * @return M62fbSituacionViv
	 */
	@RequestMapping(method = RequestMethod.PUT)
	public @ResponseBody
	M62fbSituacionViv edit(@RequestBody M62fbSituacionViv m62fbSituacionViv) {
		M62fbSituacionViv m62fbSituacionVivAux = this.m62fbSituacionVivService
				.update(m62fbSituacionViv);
		M62fbSituacionVivController.logger
				.info("[PUT] : M62fbSituacionViv actualizado correctamente");
		return m62fbSituacionVivAux;
	}

	/**
	 * Method 'add'.
	 * 
	 * @param m62fbSituacionViv
	 *            M62fbSituacionViv
	 * @return M62fbSituacionViv
	 */
	@RequestMapping(method = RequestMethod.POST)
	public @ResponseBody
	M62fbSituacionViv add(@RequestBody M62fbSituacionViv m62fbSituacionViv) {
		M62fbSituacionViv m62fbSituacionVivAux = this.m62fbSituacionVivService
				.add(m62fbSituacionViv);
		M62fbSituacionVivController.logger
				.info("[POST] : M62fbSituacionViv insertado correctamente");
		return m62fbSituacionVivAux;
	}

	/**
	 * Method 'remove'.
	 * 
	 * @param codTabla
	 *            String
	 * @param desTablaCas
	 *            String
	 * @return m62fbSituacionViv
	 */
	@RequestMapping(value = "/{codTabla}", method = RequestMethod.DELETE)
	@ResponseStatus(value = HttpStatus.OK)
	public @ResponseBody
	M62fbSituacionViv remove(@PathVariable String codTabla,
			@PathVariable String desTablaCas) {
		M62fbSituacionViv m62fbSituacionViv = new M62fbSituacionViv();
		m62fbSituacionViv.setCodTabla(codTabla);
		// m62fbSituacionViv.setDesTablaCas(desTablaCas);
		this.m62fbSituacionVivService.remove(m62fbSituacionViv);
		M62fbSituacionVivController.logger
				.info("[DELETE] : M62fbSituacionViv borrado correctamente");
		return m62fbSituacionViv;
	}

	/**
	 * Method 'removeAll'.
	 * 
	 * @param m62fbSituacionVivIds
	 *            List
	 * @return m62fbSituacionVivList
	 */
	@RequestMapping(value = "/deleteAll", method = RequestMethod.POST)
	@ResponseStatus(value = HttpStatus.OK)
	public @ResponseBody
	List<List<String>> removeMultiple(
			@RequestBody List<List<String>> m62fbSituacionVivIds) {
		List<M62fbSituacionViv> m62fbSituacionVivList = new ArrayList<M62fbSituacionViv>();
		for (List<String> m62fbSituacionVivId : m62fbSituacionVivIds) {
			Iterator<String> iterator = m62fbSituacionVivId.iterator();
			M62fbSituacionViv m62fbSituacionViv = new M62fbSituacionViv(); // NOPMD
																			// -
																			// Objeto
																			// nuevo
																			// en
																			// la
																			// lista
																			// (parametro
																			// del
																			// servicio)
			m62fbSituacionViv.setCodTabla(ObjectConversionManager.convert(
					iterator.next(), String.class));
			/*
			 * m62fbSituacionViv.setDesTablaCas(ObjectConversionManager.convert(
			 * iterator.next(), String.class));
			 */
			m62fbSituacionVivList.add(m62fbSituacionViv);
		}
		this.m62fbSituacionVivService.removeMultiple(m62fbSituacionVivList);
		M62fbSituacionVivController.logger
				.info("[POST - DELETE_ALL] : M62fbSituacionViv borrados correctamente");
		return m62fbSituacionVivIds;
	}

	/**
	 * Method 'getAllJQGrid'.
	 * 
	 * @param filterM62fbSituacionViv
	 *            M62fbSituacionViv
	 * @param pagination
	 *            Pagination
	 * @return JQGridJSONModel
	 */
	@RequestMapping(method = RequestMethod.GET, headers = { "JQGridModel=true" })
	public @ResponseBody
	JQGridJSONModel getAllJQGrid(
			@ModelAttribute M62fbSituacionViv filterM62fbSituacionViv,
			@ModelAttribute Pagination pagination) {
		List<M62fbSituacionViv> m62fbSituacionVivs = this.m62fbSituacionVivService
				.findAll(filterM62fbSituacionViv, pagination);
		Long recordNum = this.m62fbSituacionVivService
				.findAllCount(filterM62fbSituacionViv);
		M62fbSituacionVivController.logger
				.info("[GET - jqGrid] : Obtener M62fbSituacionViv");
		return new JQGridJSONModel(pagination, recordNum, m62fbSituacionVivs);
	}

}
