package com.ejie.m62fb.control;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import javax.servlet.http.HttpServletRequest;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.ui.ModelMap;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.bind.annotation.ResponseStatus;
import org.springframework.web.servlet.ModelAndView;

import com.ejie.m62fb.model.persona.Persona;
import com.ejie.m62fb.model.tipos.P28Tipos;
import com.ejie.m62fb.model.tipos.TipoClave;
import com.ejie.m62fb.model.tipos.TipoSexo;
import com.ejie.m62fb.service.registroVPP.PersonaService;
import com.ejie.m62fb.utils.bean.BeanUtils;
import com.ejie.m62fb.utils.constants.AppConstantes;
import com.ejie.m62fb.utils.properties.UtilProperties;
import com.ejie.t17i.model.Pais;
import com.ejie.t17i.service.PaisService;
import com.ejie.x38.control.bind.annotation.RequestJsonBody;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import com.ejie.x38.reports.ReportData;

/**
 * PersonaController generated by UDA, 24-oct-2012 16:55:02.
 * 
XXXX
 */

@Controller
@RequestMapping(value = "/persona")
public class PersonaController {

	private static final Logger logger = LoggerFactory
			.getLogger(PersonaController.class);
	@Autowired
	private PaisService paisService;
	@Autowired
	private PersonaService personaService;
	@Autowired
	private ComboController comboController;
	/**
	 * Method 'getById'.
	 * 
	 * @param idPersona
	 *            Integer
	 * @return persona Persona
	 */
	@RequestMapping(value = "/{idPersona}", method = RequestMethod.GET)
	public @ResponseBody
	Persona getById(@PathVariable BigDecimal idPersona) {
		Persona persona = new Persona();
		persona.setIdPersona(idPersona);
		persona = this.personaService.find(persona);
		PersonaController.logger
				.info("[GET - findBy_PK] : Obtener Persona por PK");
		return persona;
	}

	/**ContratoViviendaActMasiva'
	 * 
	 * @param persona Persona a consultar en SVDI
	 * @return ID de la petici&oacute;n generada
	 */
	@RequestMapping(value = "/insertPeticionSVDI/{tipoCodigoId}/{codigoId}/{apellido1}/{fechaNacimiento}",method = RequestMethod.POST)
	public @ResponseBody String insertPeticionSVDI(
			@PathVariable String tipoCodigoId,@PathVariable String codigoId,
			@PathVariable String apellido1,@PathVariable String fechaNacimiento) {		
		PersonaController.logger.info("[POST] PRE-Insertar petición SVDI");
		apellido1=apellido1.equalsIgnoreCase("-")?"":apellido1;
		fechaNacimiento=fechaNacimiento.equalsIgnoreCase("-")?"":fechaNacimiento;
		String idPeticion= personaService.insertPeticionSVDI(tipoCodigoId,codigoId,apellido1,fechaNacimiento);
		//String idPeticion="1";
		PersonaController.logger.info("[POST] POST-Insertar petición SVDI");
		return idPeticion;
	}
	/**
	 * 
	 * @param idPeticion ID de la petici&oacute;n a consultar
	 * @return Datos de la petición SVDI
	 */
	@RequestMapping(value = "/getResultadoSVDI/{idPeticion}", method = RequestMethod.GET)
	public @ResponseBody
	Persona getResultadoSVDI(@PathVariable String idPeticion) {
		Persona persona = new Persona();
		persona = this.personaService.getResultadoSVDI(idPeticion);
//		persona.setTipoCodigoId(new TipoClave(TipoClave.DNI));
//		persona.setCodigoId("30000529L");
//		persona.setNombre("JOSE");
//		persona.setApellido1("GARCIA");
//		persona.setApellido2("PLATA");//FEC_NACIMIENTO
//		persona.setFecNacimiento(new Date());
//		persona.setSexo(new TipoSexo(TipoSexo.VARON));
//		persona.setNacionalidad(new Pais(AppConstantes.PAIS_ESPANYA,AppConstantes.PAIS_ESPANYA_TXT));
		PersonaController.logger
				.info("[GET - getResultadoSVDI] : Obtener Resultado SVDI peticion-->" + idPeticion);
		return persona;
	}
	/**
	 * 
	 * @param idPersona
	 * @param tipoCodigoId
	 * @param codigoId
	 * @param nombre
	 * @param apellido1
	 * @param apellido2
	 * @param codProvincia
	 * @param codMunicipio
	 * @return
	 */
	@RequestMapping(value = "findAllLike", method = RequestMethod.GET)
	public @ResponseBody
	List<Persona> findAllLike(
			@RequestParam(value = "idPersona", required = false) String idPersona,
			@RequestParam(value = "tipoCodigoId.codTabla", required = false) String tipoCodigoId,
			@RequestParam(value = "codigoId", required = false) String codigoId,
			@RequestParam(value = "nombre", required = false) String nombre,
			@RequestParam(value = "apellido1", required = false) String apellido1,
			@RequestParam(value = "apellido2", required = false) String apellido2) {
		// Filtro
		Persona persona = new Persona();
		if (idPersona != null && !idPersona.isEmpty()) {
			persona.setIdPersona(new BigDecimal(idPersona));
		}
		persona.setTipoCodigoId(new TipoClave(tipoCodigoId));
		persona.setCodigoId(codigoId);
		persona.setNombre(nombre);
		persona.setApellido1(apellido1);
		persona.setApellido2(apellido2);

		return this.personaService.findAllLike(persona, null, false);
	}/**
	 * 
	 * @param idPersona
	 * @param tipoCodigoId
	 * @param codigoId
	 * @param nombre
	 * @param apellido1
	 * @param apellido2
	 * @param codProvincia
	 * @param codMunicipio
	 * @return
	 */
	@RequestMapping(value = "findAll", method = RequestMethod.GET)
	public @ResponseBody
	List<Persona> findAll(
			@RequestParam(value = "idPersona", required = false) String idPersona,
			@RequestParam(value = "tipoCodigoId.codTabla", required = false) String tipoCodigoId,
			@RequestParam(value = "codigoId", required = false) String codigoId,
			@RequestParam(value = "nombre", required = false) String nombre,
			@RequestParam(value = "apellido1", required = false) String apellido1,
			@RequestParam(value = "apellido2", required = false) String apellido2) {
		// Filtro
		Persona persona = new Persona();
		if (idPersona != null && !idPersona.isEmpty()) {
			persona.setIdPersona(new BigDecimal(idPersona));
		}
		persona.setTipoCodigoId(new TipoClave(tipoCodigoId));
		persona.setCodigoId(codigoId);
		persona.setNombre(nombre);
		persona.setApellido1(apellido1);
		persona.setApellido2(apellido2);

		return this.personaService.findAll(persona, null);
	}
	/**
	 * Operacion de filtrado del componente RUP_TABLE.
	 * 
	 * @param filterElemento Elemento
	 *            Bean que contiene los parametros de filtrado a emplear.
	 * @param jqGridRequestDto
	 *            Dto que contiene los parametros de configuracion propios del
	 *            RUP_TABLE a aplicar en el filtrado.
	 * @return JQGridResponseDto<Elemento>
	 *            Dto que contiene el resultado del filtrado realizado por el 
	 *            componente RUP_TABLE.
	 */
	@RequestMapping(value = "/filter", method = RequestMethod.POST)
	public @ResponseBody JQGridResponseDto<Persona> filter(
			@RequestJsonBody(param="filter") Persona filterPersona,
			@RequestJsonBody JQGridRequestDto jqGridRequestDto,
			HttpServletRequest request) {
		PersonaController.logger.info("[POST - filter] : Obtener Personas");
		filterPersona.setbFiltroLupa(true);
		return this.personaService.filter(filterPersona, jqGridRequestDto, false);
	}
	/**
	 * Operacion CRUD Delete. Borrado del registro correspondiente al
	 * identificador especificado.
	 *
	 * @param idPersona Integer
	 *            Identificador del objeto que se desea eliminar.
	 * @return Persona
	 *            Bean eliminado.
	 */
	@RequestMapping(value = "/{idPersona}", method = RequestMethod.DELETE)
	@ResponseStatus(value = HttpStatus.OK)
    public @ResponseBody Persona remove(@PathVariable BigDecimal idPersona) {
		Persona persona = new Persona();
        persona.setIdPersona(idPersona);
        this.personaService.remove(persona);
        PersonaController.logger.info("[DELETE] Persona borrada correctamente");
       	return persona;
    }
	/**
	 * Funcion encargada de precargar los combos para el filtro
	 * 
	 * @param model
	 *            Model
	 */
	public void precargarCombosFiltro(Model model) {
		// Estado Civil
		model.addAttribute("comboEstadoCivil", P28Tipos
				.serializeComboP28(this.comboController.getComboP28(P28Tipos.ESTADO_CIVIL)));
		// Sexo
		model.addAttribute("comboSexo", P28Tipos
				.serializeComboP28(this.comboController.getComboP28(P28Tipos.SEXO)));
		// NACIONALIDAD
		model.addAttribute("comboNacionalidad", BeanUtils.serialize(paisService.findAll(new Pais(), null), "nombre", "id"));
		
		// urlPeticionT19B
		model.addAttribute("urlPeticionT19B", UtilProperties.getProperty(AppConstantes.T19B_URL_LANZAR_PETICION));
		
	}
	/**
	 * Operacion CRUD Create. Creacion de un nuevo registro a partir del bean
	 * indicado.
	 *
	 * @param persona Persona 
	 *            Bean que contiene la informacion con la que se va a crear el
	 *            nuevo registro.
	 * @return Persona
	 *            Bean resultante del proceso de creaci&oacute;n.
	 */
	@RequestMapping(method = RequestMethod.POST)
	public @ResponseBody Persona add(@RequestBody Persona persona) {		
		Persona personaAux = this.personaService.add(persona);
        PersonaController.logger.info("[POST] : persona insertada correctamente");
    	return personaAux;
	}
	/**
	 * Operacion CRUD Edit. Modificacion del bean indicado.
	 *
	 * @param persona Persona 
	 *            Bean que contiene la informacion a modificar.
	 * @return Persona 
	 *            Bean resultante de la modificacion.
	 */
	@RequestMapping(method = RequestMethod.PUT)
    public @ResponseBody Persona edit(@RequestBody Persona persona) {		
		Persona personaAux = this.personaService.update(persona);
		PersonaController.logger.info("[PUT] : persona actualizada correctamente");
        return personaAux;
    }
	/**
	 * 
	 * @param persona
	 * @param jqGridRequestDto
	 * @param modelMap
	 * @param columns
	 * @param request
	 * @return
	 */
	@RequestMapping(value = {"xlsReport" , "xlsxReport"}, method = RequestMethod.POST)
	protected ModelAndView getExcelPOI(@ModelAttribute Persona persona, @ModelAttribute JQGridRequestDto jqGridRequestDto,
			ModelMap modelMap,
			@RequestParam(value = "columns", required = false) String columns,
			HttpServletRequest request){
		
		//Acceso a BD para recuperar datos
		List<Persona> listPersonaPage = this.personaService.findAllLike(persona, jqGridRequestDto, false);
		jqGridRequestDto.setPage(null);
		jqGridRequestDto.setRows(null);
		List<Persona> listPersonaAll = this.personaService.findAllLike(persona, jqGridRequestDto, false);
		
		//Nombre fichero
		modelMap.put("fileName", "Personas");
		
		//Datos
		List<Object> reportData = new ArrayList<Object>();
			//Hoja 1
			ReportData<Persona> personaExcelDataAll = new ReportData<Persona>();
				//nombre hoja
				personaExcelDataAll.setSheetName("Todos las Personas");
				//cabeceras hoja
				personaExcelDataAll.setHeaderNames(ReportData.parseColumns(columns));
				//datos hoja
				personaExcelDataAll.setModelData(listPersonaAll);
			reportData.add(personaExcelDataAll);
			//Hoja 2
			ReportData<Persona> personaExcelDataPage = new ReportData<Persona>();
				//nombre hoja
				personaExcelDataPage.setSheetName("Página 1 de Personas");
				//cabeceras hoja
				personaExcelDataPage.setHeaderNames(ReportData.parseColumns(columns));
				//datos hoja
				personaExcelDataPage.setModelData(listPersonaPage);
			reportData.add(personaExcelDataPage);
		modelMap.put("reportData", reportData);
		
		//Generación del XLS o XLSX
//		String reportView = request.getServletPath().substring(9);
		if (request.getServletPath().indexOf("xlsReport")!=-1){
			return new ModelAndView("xlsReport", modelMap);
		}else{
			return new ModelAndView("xlsxReport", modelMap);
		}
//		return new ModelAndView(reportView, modelMap);
		
	}
}
