package com.ejie.m62fb.control.registroVPP;

import javax.servlet.http.HttpServletRequest;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.ResponseBody;

import com.ejie.m62fb.model.ExpedienteSancionador;
import com.ejie.m62fb.service.registroVPP.ExpedienteSancionadorService;
import com.ejie.x38.control.bind.annotation.RequestJsonBody;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;

/**
 * ExpedSancionadoresController generated by UDA, 12-nov-2015 17:14:30.
 * 
XXXX
 */

@Controller
@RequestMapping(value = "/expedsancionadores")
public class ExpedSancionadoresController {

	private static final Logger logger = LoggerFactory
			.getLogger(ExpedSancionadoresController.class);

	@Autowired
	private ExpedienteSancionadorService expedienteSancionadorService;

	/*
	 * METODOS COMPONENTE RUP_TABLE
	 */

	// /**
	// * Metodo de presentacion del RUP_TABLE.
	// *
	// * @param model
	// * Model
	// * @return String
	// */
	// @RequestMapping(value = "/maint", method = RequestMethod.GET)
	// public String getFormEdit(Model model) {
	// ExpedSancionadoresController.logger
	// .info("[GET - View] : expedsancionadores");
	// return "expedsancionadores";
	// }

	/**
	 * Operacion de filtrado del componente RUP_TABLE.
	 * 
	 * @param filterExpedientesSancionadores
	 *            ExpedienteSancionador Bean que contiene los parametros de
	 *            filtrado a emplear.
	 * @param jqGridRequestDto
	 *            Dto que contiene los parametros de configuracion propios del
	 *            RUP_TABLE a aplicar en el filtrado.
	 * @param request
	 *            HttpServletRequest
	 * @return JQGridResponseDto<ExpedienteSancionador> Dto que contiene el
	 *         resultado del filtrado realizado por el componente RUP_TABLE.
	 */
	@RequestMapping(value = "/filter", method = RequestMethod.POST)
	public @ResponseBody
	JQGridResponseDto<ExpedienteSancionador> filter(
			@RequestJsonBody(param = "filter") ExpedienteSancionador filterExpedientesSancionadores,
			@RequestJsonBody JQGridRequestDto jqGridRequestDto,
			HttpServletRequest request) {
		ExpedSancionadoresController.logger
				.info("[POST - filter] : Obtener Expedientes Sancionadores");
		return this.expedienteSancionadorService.filter(
				filterExpedientesSancionadores, jqGridRequestDto, false);
	}
}
