package com.ejie.m62fb.control.registroVPP;

import java.math.BigDecimal;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.ResponseBody;

import com.ejie.m62fb.model.InformacionSuelo;
import com.ejie.m62fb.model.tipos.TipoElemento;
import com.ejie.m62fb.service.registroVPP.InformacionSueloService;

/**
 * ElementoController generated by UDA, 04-sep-2015 12:04:01.
 * 
XXXX
 */
@Controller
@RequestMapping(value = "/informacionsuelo")
public class InformacionSueloController {

	private static final Logger logger = LoggerFactory
			.getLogger(InformacionSueloController.class);

	@Autowired
	private InformacionSueloService informacionSueloService;

	/**
	 * <p>
	 * Comprueba si existe solicitud de derecho de superficie para el elemento
	 * </p>
	 * 
	 * @param numElemento
	 *            N&uacute;mero de elemento
	 * @param codTipoElemento
	 *            Tipo de elemento
	 * @return N&uacute;mero de
	 */
	@RequestMapping(value = "/existeSolicitudDchoSup/{numElemento}/{codTipoElemento}", method = RequestMethod.GET)
	public @ResponseBody
	boolean existeSolicitudDchoSup(@PathVariable BigDecimal numElemento,
			@PathVariable String codTipoElemento) {
		InformacionSueloController.logger
				.info("[GET - find_ALL] : Obtener count InformacionSuelo");
		return this.informacionSueloService
				.existeSolicitudDchoSup(new InformacionSuelo(new TipoElemento(
						codTipoElemento), numElemento));
	}
}