package com.ejie.m62fb.control.registroVPP;


import java.math.BigDecimal;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import com.ejie.m62fb.control.PersonaController;
import com.ejie.m62fb.model.Promocion;
import com.ejie.m62fb.model.direccion.Direccion;
import com.ejie.m62fb.model.persona.Persona;
import com.ejie.m62fb.service.registroVPP.PromocionService;
import com.ejie.t17i.model.Calle;
import com.ejie.t17i.model.Municipio;
import com.ejie.t17i.model.Portal;
import com.ejie.t17i.model.Provincia;

/**
 * ElementoController generated by UDA, 04-sep-2015 12:04:01.
XXXX
 */
 
@Controller
@RequestMapping(value = "/promocion")
public class PromocionController  {

	private static final Logger logger = LoggerFactory.getLogger(PromocionController.class);
	@Autowired
	private PromocionService promocionService;

	/**
	 * Method 'getById'.
	 * 
	 * @param idPersona
	 *            Integer
	 * @return persona Persona
	 */
	@RequestMapping(value = "/{idPromocion}", method = RequestMethod.GET)
	public @ResponseBody
	Promocion getById(@PathVariable BigDecimal idPromocion) {
		Promocion promocion = new Promocion();
		promocion.setIdPromocion(idPromocion);
		promocion = this.promocionService.find(promocion);
		PromocionController.logger
				.info("[GET - findBy_PK] : Obtener Promocion por PK");
		return promocion;
	}
/**
 * 
 * @param numExpediente
 * @param idProvincia
 * @param idMunicipio
 * @param idCalle
 * @param bloque
 * @param numero
 * @param bis
 * @return
 * @throws SQLException
 */
	@RequestMapping(value = "findAllLike", method = RequestMethod.GET)
	public @ResponseBody
	List<Promocion> findAllLike(
			@RequestParam(value = "q", required = false) String numExpediente,
			@RequestParam(value = "idProvincia", required = false)final String idProvincia,
			@RequestParam(value = "idMunicipio", required = false)final String idMunicipio,
			@RequestParam(value = "idCalle", required = false)final BigDecimal idCalle,
			@RequestParam(value = "bloque", required = false)final String bloque,
			@RequestParam(value = "numero", required = false)final String numero,
			@RequestParam(value = "bis", required = false)final String bis
	) throws SQLException {
		// Filtro
		Promocion promocion = new Promocion();
		if (numExpediente.isEmpty()){

			promocion=null;
		}else{

			promocion.setNumExpediente(numExpediente);
		}
		
		Direccion direccion=new Direccion();
		if(idProvincia.isEmpty() || idMunicipio.isEmpty() || idCalle==null || (bloque.isEmpty()&& numero.isEmpty() && bis.isEmpty())){
			direccion=null;
		}else{
			direccion.setProvincia(new Provincia(idProvincia));
			direccion.setMunicipio(new Municipio(idMunicipio,direccion.getProvincia()));
			direccion.setCalle(new Calle(idCalle));
			Portal portal = new Portal(bloque, numero, bis);
			direccion.setPortal(portal);
		}
		if (direccion==null && promocion == null){
			return new ArrayList<Promocion> ();
		}
		
		return this.promocionService
				.buscarPromocionPorExpedYEmplazamiento(promocion, direccion);
	}
}	
